#!/usr/bin/env python

import os,re,shutil

allfiles = os.popen('find . -type f -name "*.xml"').read().strip().split()

def rename(input,outfmt):
    #return
    global allfiles
    inre = re.compile(input)
    not_done = []
    for path in allfiles:
        d,f = os.path.split(path)
        f,e = os.path.splitext(f)
        m = inre.match(f)
        if m:
            g = m.groups()
            nf = re.sub(input,outfmt,f)
            npath = os.path.join(d,nf + e)
            print "Move %s -> %s"%(path,npath)
            os.rename(path,npath)
        else:
            not_done.append(path)
    allfiles = not_done
    grep = input
    for c in "()|?":
        grep = grep.replace(c,"\\"+c)
    reffiles = os.popen('grep -lr \'%s.xml\' . | grep -v CVS'%(grep)).read().strip().split()
    #print reffiles
    for ref in reffiles:
        print "Modify %s"%ref
        r = re.sub(input+".xml",outfmt+".xml",open(ref).read())
        open(ref,"w").write(r)

def relativize_path(source_dir,dest_path):
    s = os.path.normpath(source_dir)
    if s != '.':
        s = s.split('/')
    else:
        s = []
    d = os.path.normpath(dest_path)
    if d != '.':
        d = d.split('/')
    else:
        d = []
        
    if not s and not d: return '.'
    
    while s and d and (s[0] == d[0]):
        del s[0]
        del d[0]
    return "../"*len(s)+'/'.join(d)

def fix_relative_paths(data,root,removed_dir):
    #print root,removed_dir
    rd = os.path.split(removed_dir)[1]
    href = re.compile('(href *=|SYSTEM) *("[^"]*"|\'[^\']*\')')
    if root.endswith(removed_dir):
        newroot = root.replace(rd,'')
    elif removed_dir in root:
        newroot = root.replace(rd+'/','')
    else:
        newroot = root
    m = href.search(data)
    while m: # for each "href" in the file
        s = m.group(2)[1:-1]
        if not s.startswith("protocol") and not s.startswith("#"):
            pointed_file = os.path.normpath(os.path.join(root,s))
            if removed_dir in pointed_file:
                pointed_file = pointed_file.replace(rd+'/','')
            rel_path = relativize_path(newroot,pointed_file)
            if rel_path != s:
                #print s,"->",rel_path
                a,b = m.span(2)
                data = data[:(a+1)] + rel_path + data[b-1:]
        m = href.search(data,m.start(2))
    return data
    
def move_up(origdir):
    href = re.compile('(href *=|SYSTEM) *("[^"]*"|\'[^\']*\')')
    files = os.popen('find %s -type f -name "*.xml"'%origdir).read().strip().split()
    destdir_base,removed_dir = os.path.split(origdir)
    # move the files
    for path in files:
        d,f = os.path.split(path)
        destdir = d.replace(origdir,destdir_base)
        if not os.path.isdir(destdir):
            print "mkdir %s"%destdir
            os.makedirs(destdir)
        npath = os.path.join(destdir,f)
        print "Move %s -> %s"%(path,npath)
        os.rename(path,npath)

        orig = open(npath).read()
        dest = fix_relative_paths(orig,d,origdir)
        if dest is not orig:
            print "Fixating %s"%npath
            open(npath,"w").write(dest)
    # remove the directory tree
    shutil.rmtree(origdir)
    # fix the path referenced by others
    for root, dirs, files in os.walk('.'): # navigate the tree
        if 'CVS' in root: continue
        for f in files: # loop over all files
            #print "Reading %s"%os.path.join(root,f)
            orig = open(os.path.join(root,f)).read()
            dest = fix_relative_paths(orig,root,origdir)
            if dest is not orig:
                print "Fixating %s"%os.path.join(root,f)
                open(os.path.join(root,f),"w").write(dest)
#             for m in href.finditer(orig): # for each "href" in the file
#                 print m.group(1)
#                 hf,hn = m.group(1)[1:-1].split('#')
#                 if hf == '': continue # it is a local href
#                 pointed_file = os.path.normpath(os.path.join(root,hf))
#                 if origdir in pointed_file:
#                     hf = hf.replace(removed_dir+'/','')
#                     a,b = m.span(1)
#                     dest = dest[:(a+1)] + hf + '#' + hn + dest[b-1:]
#             if dest is not orig:
#                 print "Writing %s"%os.path.join(root,f)
#                 open(os.path.join(root,f),"w").write(dest)
    
######################################################################
# Muon (files generated by a script)
######################################################################
# GapStructureM1R1Cham010.xml -> Cham010@GapStructureM1R1.xml
rename('(GapStructure)(M[0-9]R[0-9])(Cham[0-9][0-9][0-9])','\\3@\\1\\2')

# M2R4RegStructure.xml -> M2R4@RegStructure.xml
# M2R4Cham.xml -> M2R4@Cham.xml
rename('(M[0-9]R[0-9])(RegStructure|Cham)','\\1@\\2')

######################################################################
# IT (files generated by a script)
######################################################################
# ITT1BottomLayerVLadder7Structure.xml -> BottomVL7@ITT1Structure.xml
# ITT1BottomLayerX1Ladder1Structure.xml -> BottomX1L1@ITT1Structure.xml
rename('(ITT[0-9])(Top|Left|Right|Bottom)(.*Layer)([XYVU][0-9]?)(Ladder)([0-9])(Structure)','\\2\\4L\\6@\\1\\7')

# ITT1RightBoxLayerX2Structure.xml -> ITT1RightX2@Structure.xml
# ITT1TopBoxLayerUStructure.xml -> ITT1TopU@Structure.xml
#rename('(ITT[0-9])(Top|Left|Right|Bottom)(.*BoxLayer)([XYVU][0-9]?)(Structure)','\\1\\2\\4@\\5')
# ITT1RightBoxLayerX2Structure.xml -> RightX2@ITT1Structure.xml
# ITT1TopBoxLayerUStructure.xml -> TopU@ITT1Structure.xml
rename('(ITT[0-9])(Top|Left|Right|Bottom)(.*BoxLayer)([XYVU][0-9]?)(Structure)','\\2\\4@\\1\\5')

######################################################################
# TT
######################################################################
# TTbVR1Module1TStructure.xml -> VR1M1T@TTbStructure.xml
rename('(TT[ab])([UVX]R[1-3]M)(odule)([0-9][TB])(Structure)','\\2\\4@\\1\\5')

######################################################################
# OT
######################################################################
# T1UQuarter3Structure.xml -> T1UQ3@Structure.xml
# T3X2Quarter1Structure.xml -> T3X2Q1@Structure.xml
rename('(T[1-3][UVX][1-2]?Q)(uarter)([0-9])(Structure)','\\1\\3@\\4')

######################################################################
# Velo
######################################################################
# PUModule02.xml -> M02@PUModule.xml
# Module23.xml -> M23@Module.xml
rename('((PU)?Module)([0-9][0-9])','M\\3@\\1')

# ModulePU02.xml -> M02@PUModule.xml
rename('(Module)(PU)([0-9][0-9])','M\\3@\\2\\1')

######################################################################
# Rich1
######################################################################
# RichHPDSurfaceV6TabProperty.xml -> RichHPDSurfaceTabProperty.xml
# Rich1AerogelBoxLeftV6.xml -> Rich1AerogelBoxLeft.xml
rename('(Rich.*)(V6)(.*)','\\1\\3')

basic_renames = [ ("lhcb-200601", "lhcb"),
                  ("geometry-200601", "geometry"),
                  ("structure-200601", "structure"),
                  ("materials-v250r0", "materials"),
                  ("StatPos-v249r0", "StatPos"),
                  ("geometry-v6", "geometry"),
                  ("geometry-v7", "geometry"),
                  ("structure-v7", "structure") ]
for i,o in basic_renames:
    rename(i,o)

######################################################################
# move 1 directory up
######################################################################
for d in [ "Velo/v200511", "Rich1/DetElem/v6", "Rich1/GeomParam/v6", "Rich1/LogVol/v6", "Rich1/PhysVol/v6", "Rich1/Surface/v6" ]:
    move_up(d)
