// $Id: TELL1Engine.h,v 1.2 2007/08/27 10:44:57 szumlat Exp $
#ifndef TELL1ENGINE_TELL1ENGINE_H 
#define TELL1ENGINE_TELL1ENGINE_H 1

// Include files
#include "Kernel/TELL1Core.h"

/** @class TELL1Engine TELL1Engine.h TELL1Engine/TELL1Engine.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-08-09
 */

using namespace VeloTELL1;

class TELL1Engine {
public: 
  /// Standard constructor
  TELL1Engine( );
  virtual ~TELL1Engine( ); ///< Destructor
  size_t dataSize() const;
  size_t headerStripSize() const;
  size_t linkPedestalSize() const;
  size_t linkMaskSize() const;
  void setProcessEnable(const int inValue);
  void setInData(const EngineVec& inVec);
  EngineVec& outData();
 
protected:

  template<class T>
  void tableInit(T* inData, const size_t size, int init=0)
  {
    // the tables are meant to store integers
    T* begin=inData;
    T* end=begin+size;
    std::fill(begin, end, init);
  }
  int processEnable() const;
  EngineVec& inData();
  void setOutData(const EngineVec& inVec);
  virtual void initTabMembers() { };

private:

  int m_processEnable;
  EngineVec m_inData;
  EngineVec m_outData;
  size_t m_dataSize;
  size_t m_headerStripSize;
  size_t m_linkPedestalSize;
  size_t m_linkMaskSize;

};
#endif // TELL1ENGINE_TELL1ENGINE_H
