// $Id: TELL1PedestalProcessEngine.h,v 1.2 2007/08/27 10:44:57 szumlat Exp $
#ifndef TELL1PEDESTALPROCESSENGINE_H 
#define TELL1PEDESTALPROCESSENGINE_H 1

// Include files
#include "TELL1Engine.h"
#include "Kernel/TELL1Core.h"

/** @class TELL1PedestalSubtractor TELL1PedestalSubtractor.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-05-25
 */

class TELL1PedestalProcessEngine: public TELL1Engine{
public:
  
  /// Standard constructor
  TELL1PedestalProcessEngine( );
  virtual ~TELL1PedestalProcessEngine( ); ///< Destructor
  void runSubtraction();
  int velo_pedestal_process(int pedestal_enable, int scaling_mode,
      int zs_enable, int header_correction_enable,
      HeaderStrip0 header_correction_value_strip_0,
      Header header, LinkMask link_mask,
      LinkPedestal link_pedestal, Data in_data);
  void setScalingMode(const int inValue);
  void setZSEnable(const int inValue);
  void setHeaderCorrectionFlag(const int inValue);
  void setHeaderCorrectionValues(const HeaderStrip0Vec& inData);
  void setHeaders(const EngineVec& inData);
  void setLinkPedestal(const LinkPedestalVec& inData);
  void setLinkMask(const LinkMaskVec& inData);
  virtual void initTableMembers();
 
protected:

private:

  int m_scalingMode;               /// decide how the bits shall be cut
  int m_zsEnable;                  /// clusterization enable flag
  int m_headerCorrectionFlag;      /// header corrections
  HeaderStrip0 m_headerCorrectionValueStrip0;
  EngineVec m_header;              /// header data
  LinkPedestal m_linkPedestal;     /// pedestals to subtract
  LinkMask m_linkMask;             /// pedestal masks

};
#endif // TELL1PEDESTALSUBTRACTOR_H
