// $Id: TELL1ReorderProcessEngine.h,v 1.2 2007/08/27 10:44:57 szumlat Exp $
#ifndef TELL1ENGINE_TELL1REORDERPROCESSENGINE_H 
#define TELL1ENGINE_TELL1REORDERPROCESSENGINE_H 1

// Include files
#include "TELL1Engine.h"
#include "Kernel/TELL1Core.h"
#include "GaudiKernel/Algorithm.h" // Added

/** @class TELL1ReorderProcessEngine TELL1ReorderProcessEngine.h TELL1Engine/TELL1ReorderProcessEngine.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-08-10
 */

class TELL1ReorderProcessEngine: public TELL1Engine {
public: 
  /// Standard constructor
  TELL1ReorderProcessEngine( );
  virtual ~TELL1ReorderProcessEngine( ); ///< Destructor
  void runReordering();
  int velo_reorder_channel(int reorder_mode, Data in_data);
  void setReorderMode(const int inValue);
  void setCableCorrection(const int inValue);
  int reorderMode() const;

protected:

  int velo_reorder_convert(int mode, int direction,
                           int *old_pos, int *new_pos);

private:

  int m_reorderMode;
  int m_cableError;
  bool m_customReordering;  // switches on my custom re-ordering algorithm. Might not be appropriate here

};
#endif // TELL1ENGINE_TELL1REORDERPROCESSENGINE_H
