// $Id: TELL1UpdateProcessEngine.h,v 1.2 2007/08/27 10:44:57 szumlat Exp $
#ifndef TELL1ENGINE_TELL1UPDATEPROCESSENGINE_H 
#define TELL1ENGINE_TELL1UPDATEPROCESSENGINE_H 1

// Include files
#include "TELL1Engine.h"
#include "Kernel/TELL1Core.h"

/** @class TELL1UpdateProcessEngine TELL1UpdateProcessEngine.h TELL1Engine/TELL1UpdateProcessEngine.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-08-10
 */

class TELL1UpdateProcessEngine: public TELL1Engine{
public: 
  /// Standard constructor
  TELL1UpdateProcessEngine( );
  virtual ~TELL1UpdateProcessEngine( ); ///< Destructor
  void runUpdate();
  int velo_pedestal_update(int pedestal_auto_update_enable,
      int header_correction_enable, 
      HeaderStrip0 header_correction_value_strip_0,
      Header header, Data in_data, Data pedestal_sum);
  void setHeaderCorrectionFlag(const int inValue);
  void setHeaderCorrectionValues(const HeaderStrip0 inVec);
  void setHeaders(const EngineVec& inVec);
  void setPedestalSum(const EngineVec& inVec);
  int headerCorrectionFlag() const;
  EngineVec& updatedPedestalSum();
  virtual void initTableMembers();
  
protected:

private:

  int m_headerCorrectionFlag;        /// header corrections
  HeaderStrip0 m_headerCorrectionValueStrip0;
  EngineVec m_header;                /// header data
  EngineVec m_inPedestalSum;         /// pedestal sum
  EngineVec m_outPedestalSum;        /// updated pedestal sum
  
};
#endif // TELL1ENGINE_TELL1UPDATEPROCESSENGINE_H
