// $Id: TELL1ZSProcessEngine.h,v 1.2 2007/08/27 10:44:57 szumlat Exp $
#ifndef TELL1ENGINE_TELL1ZSPROCESSENGINE_H 
#define TELL1ENGINE_TELL1ZSPROCESSENGINE_H 1

// Include files
#include "TELL1Engine.h"
#include "Kernel/TELL1Core.h"

/** @class TELL1ZSProcessEngine TELL1ZSProcessEngine.h TELL1Engine/TELL1ZSProcessEngine.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-08-12
 */

class TELL1ZSProcessEngine: public TELL1Engine{
public: 
  /// Standard constructor
  TELL1ZSProcessEngine( );
  virtual ~TELL1ZSProcessEngine( ); ///< Destructor
  void runZeroSuppression();
  int velo_zs_process(int zs_enable, HitThreshold hit_threshold,
                      LowThreshold  low_threshold_temp,
                      SumThreshold  sum_temp,
                      BoundaryStrip strip_start_temp,
                      Data in_data, u_int32_t pp_max_clusters,
                      TELL1Cluster cluster, int *clus_numb,
                      TELL1ADC adc_list, int *adc_numb);
  int velo_clusterization_process(int *zs_line,int *zs_h_line,
                                  int *zs_l_line, u_int16_t *cluster,
                                  u_int8_t *adc_list,
                                  int *pp_clus_cnt, int *pp_adc_cnt,
                                  u_int32_t pp_max_clusters,
                                  u_int8_t sum, u_int16_t strip_start,
                                  int boundary_strip);
  void setHitThresholds(const HitThresholdVec& inVec);
  void setLowThresholds(const Thresholds& inVec);
  void setSumThresholds(const Thresholds& inVec);
  void setBoundaryStrips(const BoundaryStripVec& inVec);
  u_int32_t producedClusters() const;
  int includedADCs() const;
  TELL1ClusterVec outClusters();
  TELL1ADCVec outADCS();
  virtual void initTableMembers();
  size_t hitThresholdSize() const;
  size_t lowThresholdSize() const;
  size_t sumThresholdSize() const;
  size_t boundaryStripSize() const;
  size_t clusterSize() const;
  size_t adcSize() const;
  
protected:

  void flushMemory();

private:

  HitThreshold m_hitThresholds;
  LowThreshold m_lowThresholds;
  SumThreshold m_sumThresholds;
  BoundaryStrip m_boundaryStrips;
  int m_producedClusters;
  TELL1Cluster m_clusters;
  TELL1ADC m_adcs;
  int m_includedADCS;
  size_t m_hitThSize;
  size_t m_lowThSize;
  size_t m_sumThSize;
  size_t m_boundaryStripSize;
  size_t m_clusterSize;
  size_t m_adcSize;
  TELL1ClusterVec m_rawClusters;
  TELL1ADCVec m_rawADCS;
  
};
#endif // TELL1ENGINE_TELL1ZSPROCESSENGINE_H
