// $Id: TELL1Engine.cpp,v 1.1.1.1 2007/08/26 16:20:13 szumlat Exp $
// Include files

// local
#include "TELL1Engine/TELL1Engine.h"

//-----------------------------------------------------------------------------
// Implementation file for class : TELL1Engine
//
// 2007-08-09 : Tomasz Szumlak
//-----------------------------------------------------------------------------

//=============================================================================
// Standard constructor, initializes variables
//=============================================================================
TELL1Engine::TELL1Engine(  ):
  m_processEnable ( 0 ),
  m_inData ( ),
  m_outData ( 2304, 0 ),
  m_dataSize ( sizeof(Data)/sizeof(int) ),
  m_headerStripSize ( sizeof(HeaderStrip0)/sizeof(u_int32_t) ),
  m_linkPedestalSize ( sizeof(LinkPedestal)/sizeof(u_int16_t) ),
  m_linkMaskSize ( sizeof(LinkMask)/sizeof(u_int8_t) )
{ }
//=============================================================================
// Destructor
//=============================================================================
TELL1Engine::~TELL1Engine() {}
//=============================================================================
void TELL1Engine::setProcessEnable(const int inValue)
{
  m_processEnable=inValue;
}
//=============================================================================
int TELL1Engine::processEnable() const
{
  return ( m_processEnable );
}
//=============================================================================
void TELL1Engine::setInData(const EngineVec& inData)
{
  m_inData=inData;
}
//=============================================================================
EngineVec& TELL1Engine::inData()
{
  return ( m_inData );
}
//=============================================================================
void TELL1Engine::setOutData(const EngineVec& inVec)
{
  m_outData=inVec;
}
//=============================================================================
EngineVec& TELL1Engine::outData()
{
  return ( m_outData );
}
//=============================================================================
size_t TELL1Engine::headerStripSize() const
{
  return ( m_headerStripSize );
}
//=============================================================================
size_t TELL1Engine::dataSize() const
{
  return ( m_dataSize );
}
//=============================================================================
size_t TELL1Engine::linkPedestalSize() const
{
  return ( m_linkPedestalSize );
}
//=============================================================================
size_t TELL1Engine::linkMaskSize() const
{
  return ( m_linkMaskSize );
}
//--
