// $Id: TELL1LCMSProcessEngine.cpp,v 1.1.1.1 2007/08/26 16:20:13 szumlat Exp $
// Include files 
// STL
#include<vector>
#include<algorithm>

// local
#include "TELL1Engine/TELL1LCMSProcessEngine.h"

// std
#include <iostream>

// message printing - defined it this way to comply
// with c-module
#define DEBUG_LCMS 0
#if DEBUG_LCMS
  #define PRINTF_DEBUG(fmt, arg...)   printf(fmt, ##arg)
#else
  #define PRINTF_DEBUG(fmt, arg...)   
#endif

//-----------------------------------------------------------------------------
// Implementation file for class : TELL1LCMSProcessEngine
//
// 2007-08-12 : Tomasz Szumlak
//-----------------------------------------------------------------------------

//=============================================================================
// Standard constructor, initializes variables
//=============================================================================
TELL1LCMSProcessEngine::TELL1LCMSProcessEngine(  ):
  TELL1Engine()
{ }
//=============================================================================
// Destructor
//=============================================================================
TELL1LCMSProcessEngine::~TELL1LCMSProcessEngine() {}
//=============================================================================
int TELL1LCMSProcessEngine::velo_lcms_process(int cm_enable, Data in_data)
{
	int err = 0;
	int i, j, k, t;
//	PP_CTRL_REG0             reg0;
//	int cm_enable = 0;
	
	long int mean_format;
	int  mean_temp;
	long int  slope_format;
	int  slope_temp;
	int data_without_hit[32], data_with_hit[32];
	
	long int variance_format;
	long int variance_temp;
	int F1 = 3;
	

	
	for(i=0; i<4; i++) //pp
	{
//		ecs_read_word(PP_BADDR[i]+PP_CTRL_REG0_ADDR, &reg0.All);
//		cm_enable = reg0.Sepe.CM_EN;
    if(cm_enable==0) continue;
    
		for(j=0;j<9;j++) //channel
		{
			for(k=0;k<2;k++) //link
			{ 
				for(t=0;t<32;t++)
				{	data_with_hit[t] = in_data[i][j][k*32+t]; 
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(0) :\n"BLACK);
		data_with_hit[0]=0; // set the strip with header interference to zero from the start
		for(t=0;t<32;t++)
		{
			if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
		}		
				//--------------------------------------first iteration
  			//------------------------------------- average
   			mean_format = 0x10;                     //sum_1
				for(t=0;t<32;t++)
				{	mean_format += data_with_hit[t]; //sum_1
          //if((i==0)&&(j==0))printf("init data %d\n",data_with_hit[t]);
				}
        //printf("mean: %ld\n", mean_format);
		
		
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nmean_format = %ld  ",mean_format);
				mean_temp = mean_format>>5;   //average
        //printf("mean: %d\n", mean_temp);
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"mean_temp = %d",mean_temp);
				for(t=0;t<32;t++)
				{ data_with_hit[t] -= mean_temp; 
          //if((i==1)&&(j==1))printf("after saturation %d",data_with_hit[t]);
				}
				saturate_for_8bits(data_with_hit,32);  //saturate to -128~127
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(after first mean sub) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			//if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
      //if((i==0)&&(j==0))printf("after saturation %d\n",data_with_hit[t]); 
		}		
				//------------------------------------- slope
				slope_format = 0x20;
				for(t=0;t<32;t++)
				{
					slope_format += (t-16)*data_with_hit[t];
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nslope_format = %ld  ",slope_format);
				slope_temp = slope_format>>6;
        //printf("slope: %d\n", slope_temp);
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"slope_temp = %d",slope_temp);
				if(slope_temp >127) slope_temp =127;
				else if(slope_temp <-128) slope_temp = -128;
        //printf("slope after saturation: %d\n", slope_temp);
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"slope_temp = %d",slope_temp);
				for(t=0;t<32;t++)
				{ data_with_hit[t] -= (slope_temp*(t-16)*3)>>7; 
				}
				
				saturate_for_8bits(data_with_hit,32);  //saturate to -128~127
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(after first slope sub) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			//if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
      //if((i==0)&&(j==0))printf("after saturation %d\n",data_with_hit[t]);  
		}		
				//-------------------------------------variance
				variance_format = 0x10;
				//variance_format = 0;
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nsquare result :\n"BLACK);
				for(t=0;t<32;t++)
				{
					variance_format += data_with_hit[t]*data_with_hit[t];
		if((i==1)&&(j==1))PRINTF_DEBUG(" %4X",data_with_hit[t]*data_with_hit[t]);
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nvariance_format = %ld  ",variance_format);
				variance_temp = variance_format>>5; 
				//variance_temp = variance_format; 
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"variance_temp = %ld  ",variance_temp);
				for(t=0;t<32;t++)
				  { if(((data_with_hit[t]*data_with_hit[t]*F1) > variance_temp)||(t==0)) data_without_hit[t]=0; // want to automatically disregard first 2 strips of ALink when re-calculating the LCMS
					else data_without_hit[t]=data_with_hit[t]; 
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(1) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
		}		
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_without_hit(1) :\n"BLACK);
		for(t=0;t<32;t++)
		{
      if((i==0)&&(j==0)){
      }
		}		
				//---------------------second iteration
  			//------------------------------------- average
   			mean_format = 0x10;                     //sum_1
				for(t=0;t<32;t++)
				{	mean_format += data_without_hit[t]; //sum_1
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nmean_format = %ld  ",mean_format);
				mean_temp = mean_format>>5;   //average
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"mean_temp = %d",mean_temp);
				for(t=0;t<32;t++)
				{ data_with_hit[t] -= mean_temp; 
					data_without_hit[t] -= mean_temp; 
				}
				saturate_for_8bits(data_with_hit,32);  //saturate to -128~127
				saturate_for_8bits(data_without_hit,32);  //saturate to -128~127
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(after second mean sub) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
		}		
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_without_hit((after second mean sub)) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_without_hit[t]);
		}		
				//------------------------------------- slope
				slope_format = 0x20;
				for(t=0;t<32;t++)
				{
					slope_format += (t-16)*data_without_hit[t];
				}
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\nslope_format = %ld  ",slope_format);
				slope_temp = slope_format>>6;
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"slope_temp = %d",slope_temp);
				if(slope_temp >127) slope_temp =127;
				else if(slope_temp <-128) slope_temp = -128;
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"slope_temp = %d",slope_temp);
				for(t=0;t<32;t++)
				{ data_with_hit[t] -= (slope_temp*(t-16)*3)>>7; 
				}
				saturate_for_8bits(data_with_hit,32);  //saturate to -128~127
		if((i==1)&&(j==1))PRINTF_DEBUG(RED"\ndata_with_hit(after second slope sub) :\n"BLACK);
		for(t=0;t<32;t++)
		{
			if((i==1)&&(j==1))PRINTF_DEBUG(" %2X",data_with_hit[t]);
		}		
				//------------------------------------------over
				for(t=0;t<32;t++)
				{	
					in_data[i][j][k*32+t] = data_with_hit[t]; 
				}
			}
	  }
	}
	return(err);
}
//=============================================================================
void TELL1LCMSProcessEngine::saturate_for_8bits(int *data, int line_numb)
{
	int i;
	for(i=0;i<line_numb;i++)
	{
		if(data[i]>127) data[i] =127;
		else if(data[i] < -128)data[i] = -128;
	}
}
//=============================================================================
void TELL1LCMSProcessEngine::runLCMS()
{
  // prepare data for c-module
  Data data;
  iT dataIT=**data;
  std::copy(inData().begin(), inData().end(), dataIT);
  // run the reorder c-module
  int error=velo_lcms_process(processEnable(),
                              data);
  // write reordered data
  if(!error){    
    const_iT begin=**data;
    const_iT end=begin+dataSize();
    std::copy(begin, end, outData().begin());
    assert(std::equal(begin, end, outData().begin()));
  }
}
//--

