#

setenv ACDC $1
if( $ACDC !~ ACDC* ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
if( ($ACDC != ACDC2) && ($ACDC != ACDC3) ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
shift

if( $ACDC == ACDC3 ) then
    unsetenv CONF
    setenv CONF $1
    if( $CONF !~ HP* ) then
	echo "set cable Configuration as second argument. Either HP1 or HP2."
	exit
    endif
    if( ($CONF != HP1) && ($CONF != HP2) && ($CONF != HP3) && ($CONF != HP4) ) then
	echo "set HP1, HP2, HP3 or HP4 as second command-line argument"
	exit
    endif
    shift
endif

unsetenv FILE
setenv FILE $1
if( $#argv == 0 ) then
    if($ACDC == ACDC3 ) then
	echo "set raw data FILENAME as third argument"
    else
	echo "set raw data FILENAME as second argument"
    endif
    exit
else
    if( $1 !~ *.sim ) then
	setenv INPUT_FILE $1.sim
    else
	setenv INPUT_FILE $1
    endif
    if( $INPUT_FILE =~ /castor* ) then
	setenv INPUT_FILE rfio://${INPUT_FILE}
    else
	setenv INPUT_FILE file://${INPUT_FILE}
    endif
    setenv OUTPUT_FILE `echo $INPUT_FILE | sed s/'\.sim'/'.digi'/`
endif 
shift 
echo $INPUT_FILE
echo $OUTPUT_FILE
lbcmt

setenv CMTPATH $BASE

BooleEnv v12r8
setenv CMTPATH ${CMTPATH}:/afs/cern.ch/lhcb/group/vertex/vol3/software/VETRA/VETRA_v3r1
setenv CMTPATH ${CMTPATH}:/afs/cern.ch/lhcb/software/releases/REC/REC_v3r11

source $BASE/Digi/Boole/v12r8/cmt/setup.csh
source $BASE/Velo/VeloACDC/v1r3/cmt/setup.csh

setenv XMLDDDBROOT $VELOACDCROOT/xml
setenv XMLCONDITIONSROOT $XMLDDDBROOT

if( $ACDC == ACDC3) then
    if( $CONF == HP1 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration1.xml
    endif
    if( $CONF == HP2 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration2.xml
    endif
    if( $CONF == HP3 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration3.xml
    endif
    if( $CONF == HP4 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration4.xml
    endif
else
    setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC2.xml
endif

$BOOLEROOT/$CMTCONFIG/Boole.exe $VELOACDCOPTS/Boole.opts


echo Input file: $INPUT_FILE
echo Ouput file: $OUTPUT_FILE
