#

setenv ACDC $1
if( $ACDC !~ ACDC* ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
if( ($ACDC != ACDC2) && ($ACDC != ACDC3) ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
shift

if( $ACDC == ACDC3 ) then
    unsetenv CONF
    setenv CONF $1
    if( $CONF !~ HP* ) then
	echo "set cable Configuration as second argument. Either HP1, HP2 or HP3."
	exit
    endif
    if( ($CONF != HP1) && ($CONF != HP2) && ($CONF != HP3)  && ($CONF != HP4)) then
	echo "set HP1, HP2, HP3 or HP4 as second command-line argument"
	exit
    endif
    shift
endif

unsetenv FILE
setenv FILE $1
if( $#argv == 0 ) then
    if($ACDC == ACDC3 ) then
	echo "set raw data FILENAME as third argument"
    else
	echo "set raw data FILENAME as second argument"
    endif
    exit
else 
    if( $1 !~ *.mdf && $1 !~ *.bin && $1 !~ *.digi ) then
	echo "Unrecognised filename extention. Expecting .mdf, .bin or .digi"
	exit
    else
	setenv INPUT_FILE $1
    endif
endif 
shift 
if( $#argv != 0 ) then
    shift
endif

if( -e /misc/testbeamdata/$INPUT_FILE) then
    setenv INPUT_FILE /misc/testbeamdata/${INPUT_FILE}
endif
if( -e $INPUT_FILE) then
    setenv INPUT_FILE file://${INPUT_FILE}
else if( $INPUT_FILE =~ /castor* ) then
    setenv INPUT_FILE rfio://${INPUT_FILE}
else
    if($ACDC == ACDC3 ) then
	setenv INPUT_FILE rfio:///castor/cern.ch/lhcb/testbeam/lhcbvelo/acdc3/${INPUT_FILE}
    else
	setenv INPUT_FILE rfio:///castor/cern.ch/lhcb/testbeam/lhcbvelo/2006/dataACDC2/velotbdaq01/${INPUT_FILE}
    endif
endif

lbcmt

setenv CMTPATH $BASE

PanoramixEnv v14r0
setenv CMTPATH ${CMTPATH}:/afs/cern.ch/lhcb/group/vertex/vol3/software/VETRA/VETRA_v3r3

source $BASE/Vis/Panoramix/v14r0/cmt/setup.csh
source $BASE/Velo/Vetra/v3r3/cmt/setup.csh
source $BASE/Velo/VeloACDC/v1r4/cmt/setup.csh

#The following is to ensure the newer versions of {VeloDet,PatVelo} specified in VeloACDC are picked-up first
setenv LD_LIBRARY_PATH ${VELOACDCROOT}/${CMTCONFIG}:${PANORAMIXROOT}/${CMTCONFIG}:${LD_LIBRARY_PATH}

setenv XMLDDDBROOT $VELOACDCROOT/xml
setenv XMLCONDITIONSROOT $XMLDDDBROOT

if( $ACDC == ACDC3) then
    if( $CONF == HP1 ) then
	setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration1.xml
    endif
    if( $CONF == HP2 ) then
	setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration2.xml
    endif
    if( $CONF == HP3 ) then
	setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration3.xml
    endif
    if( $CONF == HP4 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration4.xml
    endif
else
    setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC2.xml
endif

if( $INPUT_FILE !~ *digi ) then
    $PANORAMIXROOT/$CMTCONFIG/Panoramix_main.exe $VELOACDCOPTS/Panoramix.opts
else
    $PANORAMIXROOT/$CMTCONFIG/Panoramix_main.exe $VELOACDCOPTS/PanoramixSim.opts
endif

