#

setenv ACDC $1
if( $ACDC !~ ACDC* ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
if( ($ACDC != ACDC2) && ($ACDC != ACDC3) ) then
    echo "set ACDC2 or ACDC3 as first command-line argument"
    exit
endif
shift

if( $ACDC == ACDC3 ) then
    unsetenv CONF
    setenv CONF $1
    if( $CONF !~ HP* ) then
        echo "set cable Configuration as second argument. Either HP1 or HP2."
        exit
    endif
    if( ($CONF != HP1) && ($CONF != HP2) && ($CONF != HP3) && ($CONF != HP4)) then
        echo "set HP1, HP2, HP3 or HP4 as second command-line argument"
        exit
    endif
    shift
endif

unsetenv FILE
setenv FILE $1
if( $#argv == 0 ) then
    if($ACDC == ACDC3 ) then
        echo "set raw data FILENAME as third argument"
    else
        echo "set raw data FILENAME as second argument"
    endif
    exit
else
    if( $1 !~ *.mdf && $1 !~ *.bin && $1 !~ *.digi ) then
	echo "Unrecognised filename extention. Expecting .mdf, .bin or .digi"
	exit
    else
	setenv INPUT_FILE $1
    endif
    setenv ROOT_FILE `echo $INPUT_FILE | sed 's/.*\///' |  cut -f 1 -d .`.root
endif
shift

if( -e /misc/testbeamdata/$INPUT_FILE) then
    setenv INPUT_FILE /misc/testbeamdata/${INPUT_FILE}
endif
if( -e $INPUT_FILE) then
    setenv INPUT_FILE file://${INPUT_FILE}
else if( $INPUT_FILE =~ /castor* ) then
    setenv INPUT_FILE rfio://${INPUT_FILE}
else
    setenv INPUT_FILE rfio:///castor/cern.ch/lhcb/testbeam/lhcbvelo/acdc3/${INPUT_FILE}
endif

setenv OPT NZS
if( $#argv == 1 ) then
    if( ($1 == z) || ($1 == Z) ) then
        setenv OPT ZS
    endif
shift
endif
if( $INPUT_FILE =~ *.digi ) then
    setenv OPT ZS
endif
setenv ROOT_FILE `echo $ROOT_FILE | cut -f 1 -d .`_$OPT.root

lbcmt

setenv CMTPATH $BASE

VetraEnv v3r1

source $BASE/Velo/Vetra/v3r1/cmt/setup.csh
source $BASE/Velo/VeloACDC/v1r1/cmt/setup.csh
source $BASE/Online/GaudiOnline/cmt/setup.csh

setenv XMLDDDBROOT $VELOACDCROOT/xml
setenv XMLCONDITIONSROOT $XMLDDDBROOT

if( $ACDC == ACDC3) then
    if( $CONF == HP1 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration1.xml
    else if ($CONF == HP2 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration2.xml
    else if ($CONF == HP3 ) then
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration3.xml
    else
        setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC3_happy_pion_configuration4.xml
    endif
else
    setenv CONDITIONS_PATH $XMLCONDITIONSROOT/DDDB/Conditions/conditions_ACDC2.xml
endif

#setenv DIM_DNS_NODE lbonplus01.cern.ch
setenv DIM_DNS_NODE lbh8lx01.cern.ch
echo Setting DIM_DNS_NODE to:  $DIM_DNS_NODE
if( $HOST =~ plus*.daq.lhcb ) then
    if( $HOST == plus01.daq.lhcb ) then
	setenv DIM_HOST_NODE lbonplus01.cern.ch
    else if( $HOST == plus03.daq.lhcb ) then
	setenv DIM_HOST_NODE lbonplus03.cern.ch
    endif
    echo Setting DIM_HOST_NODE to:  $DIM_HOST_NODE
endif
setenv UTGID `whoami`

if( $INPUT_FILE =~ *.digi ) then
    setenv cmd $VELOACDCOPTS/VetraZSSim.opts
else
    setenv cmd $VELOACDCOPTS/Vetra$OPT.opts
endif

$BASE/Online/GaudiOnline/$CMTCONFIG/Gaudi.exe $BASE/Online/GaudiOnline/$CMTCONFIG/libGaudiOnline.so GaudiOnline -runable=LHCb::OnlineRunable -options=$cmd -msgsvc=MessageSvc -auto -loop

echo Input file: $INPUT_FILE
echo Ouput file: $ROOT_FILE
