void akbeamspot(char inFile[]) 
{

  gROOT->SetStyle("Plain");
  gStyle->SetOptFit();
  
  TFile *ff=TFile::Open(inFile);
  if ( ff == NULL ) {
    cout << " No such file!" << endl;
    return;
  }

  TString inFileTString=TString(inFile);
  Size_t dotPosition =inFileTString.Index(".root");
  TString fileTitleTString = inFileTString(0,dotPosition);
  char fileTitle[400];
  strcpy(fileTitle, fileTitleTString.Data());

  // Date
  TDatime now;
  now.Get();
  TPaveLabel *pDate = new TPaveLabel(0,0,0.3,1,now.AsSQLString(),"NDC");
  pDate->SetBorderSize(0);
  pDate->SetTextFont(32);
  pDate->SetFillColor(0);
  
  // FileTitle
  TPaveLabel *pFileTitle = new TPaveLabel( 0.55, 0, 1, 1, fileTitle, "NDC");
  pFileTitle->SetBorderSize(0);
  pFileTitle->SetTextFont(32);
  pFileTitle->SetFillColor(0); 

  float border = 0.97;
  float ghost = 0.23;
 
  TCanvas *c2 = new TCanvas("c2", "Track hitmaps", 10, 10, 700, 1000);
  TPad *pPad2 = new TPad("pPad2", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad2 = new TPad("mPad2", "Main Pad", 0.0, ghost, 1.0, border);
  TPad *ghostPad2 = new TPad("ghostPad2", "Ghost Pad", 0.0, 0.0, 1.0, ghost);
  pPad2->Draw();pPad2->cd();pDate->Draw();pFileTitle->Draw();
  c2->cd(); mPad2->Draw(); mPad2->Divide(2,3);
 
  TCanvas *c2bis = new TCanvas("c2bis", "Track hitmaps", 10, 10, 700, 1000);
  TPad *pPad2bis = new TPad("pPad2bis", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad2bis = new TPad("mPad2bis", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad2bis->Draw();pPad2bis->cd();pDate->Draw();pFileTitle->Draw();
  c2bis->cd(); mPad2bis->Draw(); mPad2bis->Divide(2,3);
 
  /* 
  TCanvas *c3 = new TCanvas("c3", "Cluster hitmaps", 10, 10, 700, 1000);
  TPad *pPad3 = new TPad("pPad3", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad3 = new TPad("mPad3", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad3->Draw();pPad3->cd();pDate->Draw();pFileTitle->Draw();
  c3->cd(); mPad3->Draw(); mPad3->Divide(2,3);
  */

  TCanvas *c4 = new TCanvas("c4", "Track hitmap Y projections", 10, 10, 700, 1000);
  TPad *pPad4 = new TPad("pPad4", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad4 = new TPad("mPad4", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad4->Draw();pPad4->cd();pDate->Draw();pFileTitle->Draw();
  c4->cd(); mPad4->Draw(); mPad4->Divide(2,3);

  TCanvas *c5 = new TCanvas("c5", "Track hitmap X projections", 10, 10, 700, 1000);
  TPad *pPad5 = new TPad("pPad5", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad5 = new TPad("mPad5", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad5->Draw();pPad5->cd();pDate->Draw();pFileTitle->Draw();
  c5->cd(); mPad5->Draw(); mPad5->Divide(2,3);

  TCanvas *c6 = new TCanvas("c6", "Extrapolated Track Residuals (R)", 10, 10, 700, 1000);
  TPad *pPad6 = new TPad("pPad6", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad6 = new TPad("mPad6", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad6->Draw();pPad6->cd();pDate->Draw();pFileTitle->Draw();
  c6->cd(); mPad6->Draw(); mPad6->Divide(2,3);

  TCanvas *c7 = new TCanvas("c7", "Extrapolated Track Residuals (Phi outer)", 10, 10, 700, 1000);
  TPad *pPad7 = new TPad("pPad7", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad7 = new TPad("mPad7", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad7->Draw();pPad7->cd();pDate->Draw();pFileTitle->Draw();
  c7->cd(); mPad7->Draw(); mPad7->Divide(2,3);

  TCanvas *c8 = new TCanvas("c8", "Extrapolated Track Residuals (Phi inner)", 10, 10, 700, 1000);
  TPad *pPad8 = new TPad("pPad8", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad8 = new TPad("mPad8", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad8->Draw();pPad8->cd();pDate->Draw();pFileTitle->Draw();
  c8->cd(); mPad8->Draw(); mPad8->Divide(2,3);

  TCanvas *c9 = new TCanvas("c9", "Extrapolated Track Residuals Angle (Phi outer)", 10, 10, 700, 1000);
  TPad *pPad9 = new TPad("pPad9", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad9 = new TPad("mPad9", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad9->Draw();pPad9->cd();pDate->Draw();pFileTitle->Draw();
  c9->cd(); mPad9->Draw(); mPad9->Divide(2,3);

  TCanvas *c10 = new TCanvas("c10", "Extrapolated Track Residuals Angle (Phi inner)", 10, 10, 700, 1000);
  TPad *pPad10 = new TPad("pPad10", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad10 = new TPad("mPad10", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad10->Draw();pPad10->cd();pDate->Draw();pFileTitle->Draw();
  c10->cd(); mPad10->Draw(); mPad10->Divide(2,3);

  TCanvas *c11 = new TCanvas("c11", "Track Slopes", 10, 10, 700, 1000);
  TPad *pPad11 = new TPad("pPad11", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad11 = new TPad("mPad11", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad11->Draw();pPad11->cd();pDate->Draw();pFileTitle->Draw();
  c11->cd(); mPad11->Draw(); mPad11->Divide(2,3);
  
  ///////////////////////////////////////// Module numbers

  int mod_soft[10] = {3,25,27,29,31,33,35,37,39,41};
  int mod_hard[10] = {26,29,23,31,30,21,37,27,24,28};
  int mod_phi[10] = {67,89,91,93,95,97,99,101,103,105};

  ///////////////////////////////////////// Track Hitmaps

  TString path_base = "VeloTrackDataMonitor/XY_hitmap_mod";
  TString title_base = "Track XY Hitmap, module ";
  TString contour_base = "VeloClusterDataMonitor/SensorContour";

  int compt = 0;

  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_soft[j];

    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_soft[j] + "/M" + mod_hard[j];
      TString contour_soft = contour_base + mod_soft[j];
      TString contour_phi = contour_base + mod_phi[j];

      compt++;      

      mPad2->cd(compt);
      TH2D *tmp = (TH2D*)ff->Get(path_soft);
      tmp->SetTitle(title);
      ff->Get(path_soft)->Draw("box");
      
      if(ff->Get(contour_soft)) {
        TH2D *tmp2 = (TH2D*)ff->Get(contour_phi);
        tmp2->SetMarkerColor(4);
        tmp2->Draw("same");
        TH2D *tmp3 = (TH2D*)ff->Get(contour_soft);
        tmp3->SetMarkerColor(3);
        tmp3->Draw("same");
      }
      
    }
  }
  
  compt = 0;

  ///////////////////////////////////////// Track Hitmap XY in 3D

  title_base = "Track XY Hitmap 3D, module ";

  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_soft[j];

    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_soft[j] + "/M" + mod_hard[j];
      
      compt++;      

      mPad2bis->cd(compt);
      TH2D *tmpbis = (TH2D*)ff->Get(path_soft);
      tmpbis->SetTitle(title);
      ff->Get(path_soft)->Draw("surf4");
      
    }
  }
  
  compt = 0;

  ///////////////////////////////////////// Track Hitmap Y Projections

  path_base = "VeloTrackDataMonitor/XY_hitmap_mod";
  title_base = "Track XY Hitmap Y Projection, module ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_soft[j];
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_soft[j] + "/M" + mod_hard[j];

      compt++;      

      mPad4->cd(compt);

      TH2D *tmp4 = (TH2D*)ff->Get(path_soft);
      TH1D *projY = tmp4->ProjectionY();
      projY->SetTitle(title);
      projY->Fit("gaus");
      projY->GetFunction("gaus")->SetLineColor(2);
      projY->GetFunction("gaus")->SetLineWidth(2);
      
    }
  }

  compt = 0;  
  
  ///////////////////////////////////////// Track Hitmap X Projections

  path_base = "VeloTrackDataMonitor/XY_hitmap_mod";
  title_base = "Track XY Hitmap X Projection, module ";

  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_soft[j];
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_soft[j] + "/M" + mod_hard[j];

      compt++;      
      mPad5->cd(compt);

      TH2D *tmp5 = (TH2D*)ff->Get(path_soft);
      TH1D *projX = tmp5->ProjectionX();
      projX->SetTitle(title);
      projX->Fit("gaus");
      projX->GetFunction("gaus")->SetLineColor(2);
      projX->GetFunction("gaus")->SetLineWidth(2);
      
    }
  }

  compt = 0;
  
  ///////////////////////////////////////// Extrapolated Track Residuals

  // R sensors
  
  path_base = "VeloTrackDataMonitor/ExtrapResids_s";
  title_base = "Extrapolated Track Residuals(um), sensor ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_soft[j];
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_soft[j] + "/M" + mod_hard[j] + " - R";

      compt++;
      
      mPad6->cd(compt);

      TH1D *tmp6 = (TH1D*)ff->Get(path_soft);
      tmp6->SetTitle(title);
      tmp6->Draw("box");
    }
  }

  compt = 0;
  
  // Phi sensors outer

  TString strip_type = "Outer";  

  path_base = "VeloTrackDataMonitor/ExtrapResids_s";
  title_base = "Extrapolated Track Residuals(um), sensor ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_phi[j] + strip_type;
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_phi[j] + strip_type + "/M" + mod_hard[j] + " - Phi";

      compt++;
      
      mPad7->cd(compt);

      TH1D *tmp7 = (TH1D*)ff->Get(path_soft);
      tmp7->SetTitle(title);
      tmp7->Draw("box");
    }
  }

  compt = 0;  

  // Phi sensors inner

  strip_type = "Inner";  

  path_base = "VeloTrackDataMonitor/ExtrapResids_s";
  title_base = "Extrapolated Track Residuals(um), sensor ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_phi[j] + strip_type;
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_phi[j] + strip_type + "/M" + mod_hard[j] + " - Phi";

      compt++;
      
      mPad8->cd(compt);

      TH1D *tmp8 = (TH1D*)ff->Get(path_soft);
      tmp8->SetTitle(title);
      tmp8->Draw("box");
    }
  }

  compt = 0;
  
  // Phi sensors outer ANGLE

  strip_type = "Outer";  

  path_base = "VeloTrackDataMonitor/ExtrapResidsPhiAngle_s";
  title_base = "Extrapolated Track Residuals(mrad), sensor ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_phi[j] + strip_type;
    if(ff->Get(path_soft)) {

      TString title = title_base + mod_phi[j] + strip_type + "/M" + mod_hard[j] + " - Phi";

      compt++;
      
      mPad9->cd(compt);

      TH1D *tmp9 = (TH1D*)ff->Get(path_soft);
      tmp9->SetTitle(title);
      tmp9->Draw("box");
    }
  }

  compt =0;  

  // Phi sensors inner ANGLE

  strip_type = "Inner";  

  path_base = "VeloTrackDataMonitor/ExtrapResidsPhiAngle_s";
  title_base = "Extrapolated Track Residuals(mrad), sensor ";
 
  for(int j=0; j<10; j++) {

    TString path_soft = path_base + mod_phi[j] + strip_type;
    if(ff->Get(path_soft)) {
      
      TString title = title_base + mod_phi[j] + strip_type + "/M" + mod_hard[j] + " - Phi";

      compt++;
      
      mPad10->cd(compt);

      TH1D *tmp10 = (TH1D*)ff->Get(path_soft);
      tmp10->SetTitle(title);
      tmp10->Draw("box");
    }
  }

  compt = 0;  

  // Track Slopes  

  path_base = "TrackDataMoniUserHistos/TrackSlopeX";
  title_base = "Track Slope X";
  
  if(ff->Get(path_base)) {
    
    compt++;
    
    mPad11->cd(compt);
    
    TH1D *tmp11 = (TH1D*)ff->Get(path_base);
    tmp11->SetTitle(title_base);
    tmp11->Draw("box");
  }
  
  path_base = "TrackDataMoniUserHistos/TrackSlopeY";
  title_base = "Track Slope Y";
  
  if(ff->Get(path_base)) {
    
    compt++;
    
    mPad11->cd(compt);
    
    TH1D *tmp12 = (TH1D*)ff->Get(path_base);
    tmp12->SetTitle(title_base);
    tmp12->Draw("box");
  }
  
  c2->Print(Form("%s.ps(",fileTitle));
  c2bis->Print(Form("%s.ps",fileTitle));
  c4->Print(Form("%s.ps",fileTitle));
  c5->Print(Form("%s.ps",fileTitle));
  c6->Print(Form("%s.ps",fileTitle));
  c7->Print(Form("%s.ps",fileTitle));
  c8->Print(Form("%s.ps",fileTitle));
  c9->Print(Form("%s.ps",fileTitle));
  c10->Print(Form("%s.ps",fileTitle));
  c11->Print(Form("%s.ps)",fileTitle));
  
  gSystem->Exec(Form("ps2pdf %s.ps",fileTitle));
  
}


