int savePlot(char plotMsg[])
{
  char plotFile[50];
  char answer;

  cout << plotMsg << ", save plot (y/n/q)";

  //  answer = getchar();
  cin >> answer;

  if ( answer == 'q' ) {
    return 1;
  }

  if ( answer == 'y' ) {
    cout << "File name: ";
    cin >> plotFile;
    c1->Print(plotFile);
  }
  return 0;
}


void badChannel(char rootFile[]) 
{
  int tell1Id = 30;
  char hybridType = 'p';
  Float_t noiseLowLimit = 1.5;
  Float_t noiseUpLimit = 3.0;
  badChannel(rootFile, tell1Id, hybridType, noiseLowLimit, noiseUpLimit);
}

void badChannel(char rootFile[], int tell1Id){
  char hybridType = 'p';
  Float_t noiseLowLimit = 1.5;
  Float_t noiseUpLimit = 3.0;
  badChannel(rootFile, tell1Id, hybridType, noiseLowLimit, noiseUpLimit);
}

void badChannel(char rootFile[], int tell1Id, char& hybridType){
  Float_t noiseLowLimit = 1.5;
  Float_t noiseUpLimit = 3.0;
  badChannel(rootFile, tell1Id, hybridType, noiseLowLimit, noiseUpLimit);
}

void badChannel(char rootFile[], int tell1Id, char& hybridType, Float_t& noiseLowLimit, Float_t& noiseUpLimit)
{
  cout << "====  ROOT file:   " << rootFile << endl;
  cout << "====  TELL1 ID:    " << tell1Id << endl;
  cout << "====  Hybrid Type: " << hybridType << endl;
  cout << "====  Bad channel standard: totNoise < " << noiseLowLimit
       << "  cmsNoise > " << noiseUpLimit << endl;
  cout << "--------------------------------------------------------" << endl;

  // Open ROOT file and access (sub)directories
  TFile *ff=TFile::Open(rootFile);
  if ( ff == NULL ) {
    cout << " No such file!" << endl;
    return;
  }

  TDirectory *tdVetra = ff->Get("Vetra");
  if ( tdVetra == NULL ) {
    cout << " No Vetra directory " << endl;
    return;
  }

  char dirName[50];
  sprintf(dirName, "ADCTELL1%d", tell1Id );
  TDirectory *tdADC = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "CommonModeTELL1%d", tell1Id );
  TDirectory *tdCommonMode = tdVetra->Get(dirName);
  if ( tdCommonMode == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "PedAndNoiseTELL1%d", tell1Id );
  TDirectory *tdPedAndNoise = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  // Some variables
  int i, j;
  int iCard;
  int iChip, iChip_old;
  int iLink, link;
  int iChannel;
  int channelNew;
  int channelOld;
  int channelSfw;
  
  int nBadChannelChip;
  int nBadChannelTotal=0;  
  char name[50];

  int pad;
  char row[10];
  int sector;
  int strip;
  int innerStrip;
  int outerStrip;
  int sector;
  int strip;
  char pa[10];
  int papad;
  int pachan;
  int chip;
  int swstrip;
  int chipchan;
  int swStripList[2048];

  Bool_t linkUsed[64];
  
  // Create map between electronics ID & software channel ID
  if ( hybridType == 'p' ) {
    FILE *fm = fopen("pccChannel-mapping.txt", "r");
    for ( i = 0; i < 2048; i++ ) {
      fscanf(fm,"%d%s%d%d%s%d%d%d%d%d",&pad,row,&innerStrip,&outerStrip,pa,&papad,&pachan,&chip,&swstrip,&chipchan);
      swStripList[chipchan] = swstrip;
    }
    fclose(fm);
  } else {
    FILE *fm = fopen("rccChannel-mapping.txt", "r");
    for ( i = 0; i < 2048; i++ ) {
      fscanf(fm,"%d%s%d%d%s%d%d%d%d%d",&pad,row,&sector,&strip,pa,&papad,&pachan,&chip,&swstrip,&chipchan);
      swStripList[chipchan] = swstrip;
    }
    fclose(fm);
  }

  // Get noise map
  TH1F *hnoiseTotMap = (TH1F *) tdPedAndNoise->Get("hRMSMap");
  TH1F *hnoiseCmsMap = (TH1F *) tdPedAndNoise->Get("hRMSAfterCMMap");
  TH1F *pedestalMap  = (TH1F *) tdPedAndNoise->Get("hPedestalMap");

  TH1F *noiseTotMapOld = (TH1F *) hnoiseTotMap->Clone("noiseTotMapOld");
  TH1F *noiseCmsMapOld = (TH1F *) hnoiseCmsMap->Clone("noiseCmsMapOld");
  TH1F *noiseTotMapNew = (TH1F *) hnoiseTotMap->Clone("noiseTotMapNew");
  TH1F *noiseCmsMapNew = (TH1F *) hnoiseCmsMap->Clone("noiseCmsMapNew");
  TH1F *noiseTotMapSfw = (TH1F *) hnoiseTotMap->Clone("noiseTotMapSfw");
  TH1F *noiseCmsMapSfw = (TH1F *) hnoiseCmsMap->Clone("noiseCmsMapSfw");
  TH1F *pedestalSfw    = (TH1F *) pedestalMap ->Clone("pedestalSfw");

  noiseTotMapOld->SetTitle("Total noise vs electronics channel");
  noiseCmsMapOld->SetTitle("Cms noise vs electronics channel");
  noiseTotMapNew->SetTitle("Total noise vs electronics channel");
  noiseCmsMapNew->SetTitle("Cms noise vs electronics channel");
  noiseTotMapSfw->SetTitle("Total noise vs software channel");
  noiseCmsMapSfw->SetTitle("Cms noise vs software channel");

  TH1F *linkInUse = new TH1F("linkInUse", "Links that are used", 64, -0.5, 63.5);
  TH1F *noiseTotDistAll = new TH1F("noiseTotDistAll", "total noise", 100, 0.0, 5.0);
  TH1F *noiseCmsDistAll = new TH1F("noiseCmsDistAll", "total CM noise", 100, 0.0, 5.0);
  TH1F *noiseTotDistInn = new TH1F("noiseTotDistInn", "total noise of inner P strips", 100, 0.0, 5.0);
  TH1F *noiseTotDistOut = new TH1F("noiseTotDistOut", "total noise of outer P strips", 100, 0.0, 5.0);

  TH1F *tmpHist;

  // Check which link is in use
  cout << "Links that are not used:" << endl;
  for ( iCard = 0; iCard < 4; iCard++ ) {
    for ( iChip = 0; iChip < 4; iChip++ ) {
      for ( iLink = 0; iLink < 4; iLink++ ) {
        link = iCard*16 + iChip*4 + iLink;
        sprintf(name, "hRMSAfterCM_%d", link);
        tmpHist = (TH1F *)tdPedAndNoise->Get(name);
        if ( tmpHist->GetMaximum(100000.0) > 0.8 ) {
          linkInUse->Fill(link);
          linkUsed[link] = 1;
        } else {
          cout << link << " ";
          linkUsed[link] = 0;
        }
        delete tmpHist;        
      }
    }
  }
  cout << endl;
  
  // Loop over all repeater cards (sector) and beetle chips and channels
  cout << "chip channel swStrip totNoise cmsNoise" << endl;
  for ( iCard = 0; iCard < 4; iCard++ ) {
    for ( iChip = 0; iChip < 4; iChip++ ) {
      nBadChannelChip = 0;
      for ( iChannel = 0; iChannel < 128; iChannel++ ) {
//         if ( iChip < 2 ) {
//           iChip_old = iChip+2;
//         } else {
//           iChip_old = iChip-2;
//         }
        iChip_old = iChip;
        link = iCard*16 + iChip*4 + iChannel/32;
        
        channelOld = iCard*512 + iChip_old*128 + iChannel;
        channelNew = iCard*512 + iChip*128 + iChannel;
        channelSfw = swStripList[channelNew];
        
        Float_t noiseTot = noiseTotMapOld->GetBinContent(channelOld+1);
        Float_t noiseCms = noiseCmsMapOld->GetBinContent(channelOld+1);
        
        noiseTotMapNew->SetBinContent(channelNew+1, noiseTot);
        noiseCmsMapNew->SetBinContent(channelNew+1, noiseCms);
        noiseTotMapSfw->SetBinContent(channelSfw+1, noiseTot);
        noiseCmsMapSfw->SetBinContent(channelSfw+1, noiseCms);
        
        Float_t ped = pedestalMap->GetBinContent(channelOld+1);
        pedestalSfw->SetBinContent(channelSfw+1, ped);
        
        if ( linkUsed[link] ) {          
          noiseTotDistAll->Fill(noiseTot);
          noiseCmsDistAll->Fill(noiseCms);
          if ( hybridType == 'p' ) {
            if ( channelSfw < 683 ) {
              noiseTotDistInn->Fill(noiseTot);
            } else {
              noiseTotDistOut->Fill(noiseTot);
            }
          }

          // bad channels
          if ( noiseCms > noiseUpLimit || noiseTot < noiseLowLimit ) {
            nBadChannelChip ++;
            nBadChannelTotal ++;
            
            streamsize prec = cout.precision();
            cout.width(4);
            cout << iCard*4+iChip << " ";
            cout.width(7);
            cout << iChannel << " ";
            cout.width(7);
            cout << channelSfw << " ";
            cout.precision(4);
            cout.width(8);
            cout << noiseTot << " ";
            cout.width(8);
            cout << noiseCms << endl;
            cout.precision(prec);
          }
        }        
      }
//       if ( nBadChannelChip > 0 ) {
//         cout << "---- chip " << iCard*4 + iChip
//              << " has " << nBadChannelChip
//              << " bad channels" << endl;     
//      }
    }
  }
  cout << "=========== Total bad channel for this hybrid "
       << nBadChannelTotal << endl;

// print plots
  TCanvas *c1 = new TCanvas("c1","",10,10,600,600);
  gStyle->SetOptStat("n"); // name only
  gStyle->SetOptFit(111);

  // Links used
  linkInUse->SetLineColor(4);
  linkInUse->Draw("hist");
  c1->Update();
  if ( savePlot("Links that are used") ) return;

//   // Total noise and CM subtracted noise vs electronics channel

//   noiseTotMapNew->SetTitle("Noise vs electronic channel");
//   noiseTotMapNew->SetMinimum(0.0);
//   //  noiseTotMapNew->SetMaximum(3.99);
//   noiseTotMapNew->SetLineColor(4);
//   noiseTotMapNew->SetLineWidth(1);
//   noiseCmsMapNew->SetLineColor(2);
//   noiseCmsMapNew->SetLineWidth(1);
//   noiseTotMapNew->Draw("hist");
//   noiseCmsMapNew->Draw("histsame");
//   c1->Update();
//   if ( savePlot("Noise(total/cms) vs electronics channel") ) return;

//   // Total noise and CM subtracted noise vs software channel
//   noiseTotMapSfw->SetTitle("Noise vs software channel");
//   noiseTotMapSfw->SetMinimum(0.0);
//   // noiseTotMapSfw->SetMaximum(3.99);
//   noiseTotMapSfw->SetLineColor(4);
//   noiseTotMapSfw->SetLineWidth(1);
//   noiseCmsMapSfw->SetLineColor(2);
//   noiseCmsMapSfw->SetLineWidth(1);
//   noiseTotMapSfw->Draw("hist");
//   noiseCmsMapSfw->Draw("histsame");
//   c1->Update();
//   if ( savePlot("Noise(total/cms) vs software channel") ) return;

//  // Total noise and CM subtracted noise vs software channel
//   pedestalMap->SetTitle("Pedestal vs electronic channel");
//   pedestalMap->SetMinimum(480.0);
//   pedestalMap->SetLineColor(4);
//   pedestalMap->SetLineWidth(1);
//   pedestalMap->Draw("hist");
//   c1->Update();
//   if ( savePlot("Pedestal vs electronic channel") ) return;

// // Total noise and CM subtracted noise vs software channel
//   pedestalSfw->SetTitle("Pedestal vs software channel");
//   pedestalSfw->SetMinimum(480.0);
//   pedestalSfw->SetLineColor(4);
//   pedestalSfw->SetLineWidth(1);
//   pedestalSfw->Draw("hist");
//   c1->Update();
//   if ( savePlot("Pedestal vs software channel") ) return;


  // Total noise and CM subtracted noise distribution
  //  noiseTotDistAll->Fit("gaus","");  
  //  noiseCmsDistAll->Fit("gaus","");
  Float_t totMean = noiseTotDistAll->GetMean();
  Float_t totRms  = noiseTotDistAll->GetRMS();
  Float_t cmsMean = noiseCmsDistAll->GetMean();
  Float_t cmsRms  = noiseCmsDistAll->GetRMS();
  cout << "Total noise mean: " << totMean
       << "    rms: " << totRms
       << endl;
  cout << "Cms noise mean: " << cmsMean
       << "    rms: " << cmsRms
       << endl;

  Double_t yMaxPlot1 = noiseTotDistAll->GetMaximum(1000000.0);
  Double_t yMaxPlot2 = noiseCmsDistAll->GetMaximum(1000000.0);
  Double_t yMaxPlot = yMaxPlot1 > yMaxPlot2 ? yMaxPlot1 : yMaxPlot2;
  gStyle->SetOptStat(1); // name only
  noiseTotDistAll->SetTitle("Noise distribution");
  noiseTotDistAll->SetMaximum(1.15*yMaxPlot);
  noiseTotDistAll->SetLineColor(4);
  noiseTotDistAll->SetFillColor(4);
  noiseCmsDistAll->SetLineColor(2);
  noiseCmsDistAll->SetLineWidth(2);
  noiseTotDistAll->Draw("hist");
  noiseCmsDistAll->Draw("histsame");
  c1->Update();
  if ( savePlot("Noise(total/cms) distribution") ) return;

//   if ( hybridType == 'p' ) {
//     Double_t yMaxPlot1 = noiseTotDistOut->GetMaximum(1000000.0);
//     Double_t yMaxPlot2 = noiseTotDistInn->GetMaximum(1000000.0);
//     Double_t yMaxPlot = yMaxPlot1 > yMaxPlot2 ? yMaxPlot1 : yMaxPlot2;
//     noiseTotDistOut->SetTitle("Total noise of different strip size");
//     noiseTotDistOut->SetMaximum(1.15*yMaxPlot);
//     noiseTotDistOut->SetFillColor(4);
//     noiseTotDistInn->SetFillColor(2);
//     noiseTotDistOut->Draw("hist");
//     noiseTotDistInn->Draw("histsame");
//     c1->Update();
//     if ( savePlot("Total noise of inner and outer P strips") ) return;
//   }

}


