void display(char rootFile[]) {
  int tell1Id = 30;
  display(rootFile, tell1Id);
}


void display(char rootFile[], int tell1Id) {
  cout << "====  ROOT file:  " << rootFile << endl;
  cout << "====  TELL1 ID:   " << tell1Id << endl;
  
  // Open ROOT file and access (sub)directories
  TFile *ff=TFile::Open(rootFile);
  if ( ff == NULL ) {
    cout << " No such file!" << endl;
    return;
  }

  TDirectory *tdVetra = ff->Get("Vetra");
  if ( tdVetra == NULL ) {
    cout << " No Vetra directory " << endl;
    return;
  }

  char dirName[50];
  sprintf(dirName, "ADCTELL1%d", tell1Id );
  TDirectory *tdADC = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "CommonModeTELL1%d", tell1Id );
  TDirectory *tdCommonMode = tdVetra->Get(dirName);
  if ( tdCommonMode == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "PedAndNoiseTELL1%d", tell1Id );
  TDirectory *tdPedAndNoise = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  // No statistics
	gStyle->SetOptStat(0);

	char name[50];
  char DataFile[50];
	TH1F *AllChannels;
	TH1F *AllChannelsAfterCM;
	TH1F *AllNoise;
	TH1F *AllNoiseAfterCM;
	
	AllChannels = (TH1F*) tdADC->Get("hAllChannels");
	TCanvas *c2 = new TCanvas("c2", "the great gig in the sky", 1);
	AllChannels->GetYaxis()->SetRange(400,600);
	AllChannels->Draw("box");
	
	//name = DataFile+"_allchannels.ps";// 
	sprintf(name,"%s_allchannels.ps", DataFile);
	
	c2->Print(name);
	
	TCanvas *c3 = new TCanvas("c3", "the best canvas ever", 1);
	AllChannelsAfterCM = (TH1F*) tdCommonMode->Get("hAllChannelsAfterCM");
  AllChannelsAfterCM->SetTitle("All Channel ADC after CM");
	AllChannelsAfterCM->Draw("box");
	
	TCanvas *c4 = new TCanvas("c4", "Not so nice, but Whatever", 1);
	AllNoise =  (TH1F*) tdPedAndNoise->Get("hRMSMap");
	AllNoiseAfterCM = (TH1F*) tdPedAndNoise->Get("hRMSAfterCMMap");
	AllNoise->SetMaximum(5.0);
	AllNoise->Draw("histo");
	AllNoiseAfterCM->SetLineColor(2);
	AllNoiseAfterCM->Draw("histosame");
	sprintf(name,"%s_noise.ps", DataFile);
	c4->Print(name);
	

}
