display(char* title)
{
  //gROOT->SetBatch();
  TDatime now;
  now.Get();
  TPaveLabel *pDate = new TPaveLabel(0,0,0.3,1,now.AsSQLString(),"NDC");
  pDate->SetBorderSize(0);
  pDate->SetTextFont(32);
  pDate->SetFillColor(0);

  TPaveLabel *pTitle = new TPaveLabel( 0.4 , 0 , 1 , 1 ,title,"NDC");
  pTitle->SetBorderSize(0);
  pTitle->SetTextFont(32);
  pTitle->SetFillColor(0); 

  gROOT->SetStyle("Plain");
  TFile *file = TFile::Open(Form("%s",title));
  float border = 0.98;

  TCanvas *c1 = new TCanvas("CM-suppressedADCs","CM-suppressed ADCs",600,1000);
  TPad *pPad = new TPad("pPad", "Title Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad = new TPad("mPad", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad->Draw();pPad->cd();pDate->Draw();pTitle->Draw();
  c1->cd();mPad->Draw();mPad->Divide(3,4);

  mPad->cd(1);
  if(file->Cd("/Vetra/CommonModeTELL121")){
    hAllChannelsAfterCM->SetTitle("Mod 26 (R) (TELL1 21)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(2);
  if(file->Cd("/Vetra/CommonModeTELL162")){
    hAllChannelsAfterCM->SetTitle("Mod 29 (R) (TELL1 62)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(3);
  if(file->Cd("/Vetra/CommonModeTELL161")){
    hAllChannelsAfterCM->SetTitle("Mod 23 (R) (TELL1 61)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(4);
  if(file->Cd("/Vetra/CommonModeTELL150")){
    hAllChannelsAfterCM->SetTitle("Mod 31 (R) (TELL1 50)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(5);
  if(file->Cd("/Vetra/CommonModeTELL149")){
    hAllChannelsAfterCM->SetTitle("Mod 30 (R) (TELL1 49)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(6);
  if(file->Cd("/Vetra/CommonModeTELL124")){
    hAllChannelsAfterCM->SetTitle("Mod 28 (R) (TELL1 24)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(7);
  if(file->Cd("/Vetra/CommonModeTELL130")){
    hAllChannelsAfterCM->SetTitle("Mod 26 (#phi) (TELL1 30)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(8);
  if(file->Cd("/Vetra/CommonModeTELL129")){
    hAllChannelsAfterCM->SetTitle("Mod 29 (#phi) (TELL1 29)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(9);
  if(file->Cd("/Vetra/CommonModeTELL123")){
    hAllChannelsAfterCM->SetTitle("Mod 31 (#phi) (TELL1 23)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(10);
  if(file->Cd("/Vetra/CommonModeTELL151")){
    hAllChannelsAfterCM->SetTitle("Mod 31 (#phi) (TELL1 51)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(11);
  if(file->Cd("/Vetra/CommonModeTELL127")){
    hAllChannelsAfterCM->SetTitle("Mod 30 (#phi) (TELL1 27)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }
  mPad->cd(12);
  if(file->Cd("/Vetra/CommonModeTELL125")){
    hAllChannelsAfterCM->SetTitle("Mod 28 (#phi) (TELL1 25)");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("Channel no.");
    hAllChannelsAfterCM->GetXaxis()->SetTitle("CM-suppressed ADC count");
    hAllChannelsAfterCM->GetXaxis()->SetRange(0,2048);
    hAllChannelsAfterCM->GetYaxis()->SetRangeUser(-30,100);
    hAllChannelsAfterCM->Draw("box");
  }

  TCanvas *c2 = new TCanvas("projectionsNZS","Projection of R-sensors after CMS (from NZS)",600,1000);
  TPad *pPad2 = new TPad("pPad2", "Title Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad2 = new TPad("mPad2", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad2->Draw();pPad2->cd();pDate->Draw();pTitle->Draw();
  c2->cd();mPad2->Draw();mPad2->Divide(3,4);

  float max = 100;

  mPad2->cd(1);  
  if(file->Cd("/Vetra/CommonModeTELL121")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 26 (R) (TELL1 21)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(2);  
  if(file->Cd("/Vetra/CommonModeTELL162")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 29 (R) (TELL1 62)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(3);  
  if(file->Cd("/Vetra/CommonModeTELL161")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 23 (R) (TELL1 61)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(4);  
  if(file->Cd("/Vetra/CommonModeTELL150")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 30 (R) (TELL1 50)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(5);  
  if(file->Cd("/Vetra/CommonModeTELL149")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 23 (R) (TELL1 49)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(6);  
  if(file->Cd("/Vetra/CommonModeTELL124")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 28 (R) (TELL1 24)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(7);  
  if(file->Cd("/Vetra/CommonModeTELL130")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 26 (R) (TELL1 30)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(8);  
  if(file->Cd("/Vetra/CommonModeTELL129")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 29 (#phi) (TELL1 29)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(9);  
  if(file->Cd("/Vetra/CommonModeTELL123")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 23 (#phi) (TELL1 23)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(10);  
  if(file->Cd("/Vetra/CommonModeTELL151")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 31 (#phi) (TELL1 51)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(11);  
  if(file->Cd("/Vetra/CommonModeTELL127")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 30 (#phi) (TELL1 27)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }
  mPad2->cd(12);  
  if(file->Cd("/Vetra/CommonModeTELL125")){
    hAllChannelsAfterCM_Proj->SetTitle("Mod 28 (#phi) (TELL1 25)");
    hAllChannelsAfterCM_Proj->SetDrawOption("hist");  
    hAllChannelsAfterCM_Proj->SetMaximum(max);  
    hAllChannelsAfterCM_Proj->Draw();
  }

  gStyle->SetOptStat(10);
  gStyle->SetStatW(0.3);
  gStyle->SetStatH(0.3);

  if(file->Cd("/Vetra/Rcorrelations")){
    TCanvas *c3 = new TCanvas("correlationsNZS","Correlation plots (from NZS)",600,1000);
    TPad *pPad3 = new TPad("pPad3", "Title Pad", 0.0, border, 1.0, 1.0);
    TPad *mPad3 = new TPad("mPad3", "Main Pad", 0.0, 0.0, 1.0, border);
    pPad3->Draw();pPad3->cd();pDate->Draw();pTitle->Draw();
    c3->cd();mPad3->Draw();mPad3->Divide(2,3);
    
    mPad3->cd(1);
    correlations21vs62->GetXaxis()->SetTitle("Mod 26 (R)");
    correlations21vs62->GetXaxis()->SetRangeUser(0,2048);
    correlations21vs62->GetYaxis()->SetTitle("Mod 29 (R)");
    correlations21vs62->GetYaxis()->SetRangeUser(0,2048);
    correlations21vs62->Draw("box");
    
    mPad3->cd(2);
    correlations21vs61->GetXaxis()->SetTitle("Mod 26 (R)");
    correlations21vs61->GetXaxis()->SetRangeUser(0,2048);
    correlations21vs61->GetYaxis()->SetTitle("Mod 23 (R)");
    correlations21vs61->GetYaxis()->SetRangeUser(0,2048);
    correlations21vs61->Draw("box");

    mPad3->cd(3);
    correlations21vs50->GetXaxis()->SetTitle("Mod 26 (R)");
    correlations21vs50->GetXaxis()->SetRangeUser(0,2048);
    correlations21vs50->GetYaxis()->SetTitle("Mod 31 (R)");
    correlations21vs50->GetYaxis()->SetRangeUser(0,2048);
    correlations21vs50->Draw("box");

    mPad3->cd(4);
    correlations21vs49->GetXaxis()->SetTitle("Mod 26 (R)");
    correlations21vs49->GetXaxis()->SetRangeUser(0,2048);
    correlations21vs49->GetYaxis()->SetTitle("Mod 30 (R)");
    correlations21vs49->GetYaxis()->SetRangeUser(0,2048);
    correlations21vs49->Draw("box");

    mPad3->cd(5);
    correlations21vs24->GetXaxis()->SetTitle("Mod 26 (R)");
    correlations21vs24->GetXaxis()->SetRangeUser(0,2048);
    correlations21vs24->GetYaxis()->SetTitle("Mod 28 (R)");
    correlations21vs24->GetYaxis()->SetRangeUser(0,2048);
    correlations21vs24->Draw("box");
  }

  if(file->Cd("/Vetra/Phicorrelations")){
    TCanvas *c4 = new TCanvas("correlationsNZS","Correlation plots (from NZS)",600,1000);
    TPad *pPad4 = new TPad("pPad4", "Title Pad", 0.0, border, 1.0, 1.0);
    TPad *mPad4 = new TPad("mPad4", "Main Pad", 0.0, 0.0, 1.0, border);
    pPad4->Draw();pPad4->cd();pDate->Draw();pTitle->Draw();
    c4->cd();mPad4->Draw();mPad4->Divide(2,3);
    
    mPad4->cd(1);
//     correlations23vs30->GetXaxis()->SetTitle("Mod 23 (#phi)");
//     correlations23vs30->GetXaxis()->SetRangeUser(0,2048);
//     correlations23vs30->GetYaxis()->SetTitle("Mod 26 (#phi)");
//     correlations23vs30->GetYaxis()->SetRangeUser(0,2048);
//     correlations23vs30->Draw("box");

    mPad4->cd(2);
    correlations23vs29->GetXaxis()->SetTitle("Mod 23 (#phi)");
    correlations23vs29->GetXaxis()->SetRangeUser(0,2048);
    correlations23vs29->GetYaxis()->SetTitle("Mod 29 (#phi)");
    correlations23vs29->GetYaxis()->SetRangeUser(0,2048);
    correlations23vs29->Draw("box");

    mPad4->cd(3);
    correlations23vs51->GetXaxis()->SetTitle("Mod 23 (#phi)");
    correlations23vs51->GetXaxis()->SetRangeUser(0,2048);
    correlations23vs51->GetYaxis()->SetTitle("Mod 31 (#phi)");
    correlations23vs51->GetYaxis()->SetRangeUser(0,2048);
    correlations23vs51->Draw("box");

    mPad4->cd(4);
    correlations23vs27->GetXaxis()->SetTitle("Mod 23 (#phi)");
    correlations23vs27->GetXaxis()->SetRangeUser(0,2048);
    correlations23vs27->GetYaxis()->SetTitle("Mod 30 (#phi)");
    correlations23vs27->GetYaxis()->SetRangeUser(0,2048);
    correlations23vs27->Draw("box");

    mPad4->cd(5);
    correlations23vs25->GetXaxis()->SetTitle("Mod 23 (#phi)");
    correlations23vs25->GetXaxis()->SetRangeUser(0,2048);
    correlations23vs25->GetYaxis()->SetTitle("Mod 28 (#phi)");
    correlations23vs25->GetYaxis()->SetRangeUser(0,2048);
    correlations23vs25->Draw("box");
  }
  
   
  //c1->Print(Form("%s.ps(",title));
  //c2->Print(Form("%s.ps",title));
  //c3->Print(Form("%s.ps",title));
  //c4->Print(Form("%s.ps)",title));

  //gSystem->Exec(Form("ps2pdf %s.ps ; rm -f %s.ps ; cp %s.pdf ~/tempCopy1.pdf",title,title,title));
  //cout << Form("Try:   acroread ~lhcbvelo/tempCopy.pdf",title) << endl;
}

