plot(){

  gROOT->SetStyle("Plain");
  gStyle->SetOptStat(0);
  gStyle->SetTitleFontSize(0.5);
  gROOT->SetBatch(kTRUE);

  TString title("ZeroSuppressedData");

  TFile *ClusterHisto = new TFile(Form("%s.root",title.Data()));
  ClusterHisto->cd("VeloClusterDataMonitor");
  int nEvt = nEvents->GetBinContent(1);

  TDatime now;
  now.Get();
  TPaveLabel pDate(0,.95,0.3,1.05,now.AsSQLString(),"NDC");
  pDate.SetBorderSize(0);
  pDate.SetTextFont(32);
  pDate.SetFillColor(0);

  TPaveLabel pTitle( 0.4 , 0.95 , 1.1 , 1.05 ,Form("%s.bin  (histogramming %i events)",title.Data(),nEvt),"NDC");
  pTitle.SetBorderSize(0);
  pTitle.SetTextFont(32);
  pTitle.SetFillColor(0);

  int cw = 660;
  int ch = 990;

  TCanvas *a0 = new TCanvas("ClusterHisto01","General Cluster parameters",cw,ch);
  pDate.Draw();pTitle.Draw();

  a0->Divide(2,3);

  a0->cd(2); ClusterADC->Draw();
  a0->cd(1); Tell1ID_vs_SensorID->Draw("BOX");
  a0->cd(3); ClusterSize->Draw();
  a0->cd(4); ClusterSizeVsSensor->Draw("BOX");
  a0->cd(5); RPhiRatioVsModule->Draw("BOX");
  a0->cd(6); nClusters->Draw();

  TCanvas a1("ClusterHisto02","Clusters Phi vs Z",cw,ch);
  pDate.Draw();pTitle.Draw();
  a1.Divide(2,2);

  a1.cd(1); ClusterPhi->Draw();
  a1.cd(2); ClusterPhiVsZ->Draw("BOX");
  ClusterPhiVsZ->GetXaxis()->SetRangeUser(-20,0);
  ClusterPhiVsZ->GetXaxis()->SetTitle("Z(cm)");
  ClusterPhiVsZ->GetYaxis()->SetTitle("Phi(degrees)");
  a1.cd(3); ClusterPhiVsZ_Inner->Draw("BOX");
  ClusterPhiVsZ_Inner->GetXaxis()->SetRangeUser(-20,0);
  ClusterPhiVsZ_Inner->GetXaxis()->SetTitle("Z(cm)");
  ClusterPhiVsZ_Inner->GetYaxis()->SetTitle("Phi(degrees)");
  a1.cd(4); ClusterPhiVsZ_Outer->Draw("BOX");
  ClusterPhiVsZ_Outer->GetXaxis()->SetRangeUser(-20,0);
  ClusterPhiVsZ_Outer->GetXaxis()->SetTitle("Z(cm)");
  ClusterPhiVsZ_Outer->GetYaxis()->SetTitle("Phi(degrees)");

  TCanvas a2("ClusterHisto03","Clusters R vs Z",cw,ch);
  pDate.Draw();pTitle.Draw();
  a2.Divide(2,3);

  a2.cd(1); ClusterR->Draw();
  a2.cd(2); ClusterRvsZ->Draw("BOX");
  ClusterRvsZ->GetXaxis()->SetRangeUser(-20,0);
  ClusterRvsZ->GetXaxis()->SetTitle("Z(cm)");
  ClusterRvsZ->GetYaxis()->SetTitle("R(cm)");
  a2.cd(3);
  if(ClusterRvsZ_z0){ 
    ClusterRvsZ_z0->Draw("BOX");
    ClusterRvsZ_z0->GetXaxis()->SetRangeUser(-20,0);
    ClusterRvsZ_z0->GetXaxis()->SetTitle("Z(cm)");
    ClusterRvsZ_z0->GetYaxis()->SetTitle("R(cm)");
  }
//   a2.cd(4);
//   if(ClusterRvsZ_z1){ 
//     ClusterRvsZ_z1->Draw("BOX");
//     ClusterRvsZ_z1->GetXaxis()->SetRangeUser(-20,0);
//     ClusterRvsZ_z1->GetXaxis()->SetTitle("Z(cm)");
//     ClusterRvsZ_z1->GetYaxis()->SetTitle("R(cm)");
//   }
//   a2.cd(5); 
//   if(ClusterRvsZ_z2){ 
//     ClusterRvsZ_z2->Draw("BOX");
//     ClusterRvsZ_z2->GetXaxis()->SetRangeUser(-20,0);
//     ClusterRvsZ_z2->GetXaxis()->SetTitle("Z(cm)");
//     ClusterRvsZ_z2->GetYaxis()->SetTitle("R(cm)");
//   }
  a2.cd(6);
  if(ClusterRvsZ_z3){ 
    ClusterRvsZ_z3->Draw("BOX");
    ClusterRvsZ_z3->GetXaxis()->SetRangeUser(-20,0);
    ClusterRvsZ_z3->GetXaxis()->SetTitle("Z(cm)");
    ClusterRvsZ_z3->GetYaxis()->SetTitle("R(cm)");
  }

  //-----------------------------------------------------------------------------
  //Draw ADC of clusters vs strip for each sensor
  //----------------------------------------------------------------------------

  TCanvas b("ClusterHisto04","ADC vs strip for each sensor",cw,ch);
  pDate.Draw();pTitle.Draw();

  b.Divide(2,3);
  //b.cd(1); ClusterADCvsStrip_s1->Draw("BOX");
  b.cd(2); ClusterADCvsStrip_s3->Draw("BOX");
  b.cd(3); ClusterADCvsStrip_s5->Draw("BOX");
  //b.cd(4); ClusterADCvsStrip_s65->Draw("BOX");
  b.cd(5); ClusterADCvsStrip_s67->Draw("BOX");
  b.cd(6); ClusterADCvsStrip_s69->Draw("BOX");

  //-----------------------------------------------------------------------------
  //Draw position of clusters on each sensors
  //-----------------------------------------------------------------------------

  TCanvas c("ClusterHisto07","Cluster in Phi and R sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  c.Divide(2,3);

  //c.cd(1); ClusterR_s1->Draw();
  c.cd(3); ClusterR_s3->Draw();
  c.cd(5); ClusterR_s5->Draw();
  //c.cd(2); ClusterPhi_s65->Draw();
  c.cd(4); ClusterPhi_s67->Draw();
  c.cd(6); ClusterPhi_s69->Draw();

  TCanvas c1("ClusterHisto08","Number of clusters in R and Phi sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  c1.Divide(2,3);

  c1.cd(2); nClustersVsPhiSensor->Draw();
  c1.cd(4); nClustersVsRsensor->Draw();
  //c1.cd(1); nR_vs_nPhi_mod1->Draw("BOX");
  //nR_vs_nPhi_mod1->GetXaxis()->SetTitle("#R clusters");
  //nR_vs_nPhi_mod1->GetYaxis()->SetTitle("#Phi clusters");
  c1.cd(3); nR_vs_nPhi_mod3->Draw("BOX");
  nR_vs_nPhi_mod3->GetXaxis()->SetTitle("#R clusters");
  nR_vs_nPhi_mod3->GetYaxis()->SetTitle("#Phi clusters");
  c1.cd(5); nR_vs_nPhi_mod5->Draw("BOX");
  nR_vs_nPhi_mod5->GetXaxis()->SetTitle("#R clusters");
  nR_vs_nPhi_mod5->GetYaxis()->SetTitle("#Phi clusters");

  if(0){

  ClusterHisto->cd("ClusterDataMoniUserHistos");

  //-----------------------------------------------------------------------------
  //Draw channels vs channels for all sensors pairs histograms
  //-----------------------------------------------------------------------------

  TCanvas d("ClusterHisto10","Channels vs Channels of all sensors pair",cw,ch);
  pDate.Draw();pTitle.Draw();

  d.Divide(2,4);

  d.cd(1); channel_s1_vs_channel_s3->Draw();
  channel_s1_vs_channel_s3->GetXaxis()->SetTitle("Channel ID sensor1");
  channel_s1_vs_channel_s3->GetYaxis()->SetTitle("Channel ID sensor3");

  d.cd(2); channel_s1_vs_channel_s5->Draw();
  channel_s1_vs_channel_s5->GetXaxis()->SetTitle("Channel ID sensor1");
  channel_s1_vs_channel_s5->GetYaxis()->SetTitle("Channel ID sensor5");

  d.cd(3); channel_s3_vs_channel_s5->Draw();
  channel_s3_vs_channel_s5->GetXaxis()->SetTitle("Channel ID sensor3");
  channel_s3_vs_channel_s5->GetYaxis()->SetTitle("Channel ID sensor5");

  d.cd(4); channel_s65_vs_channel_s67->Draw();
  channel_s65_vs_channel_s67->GetXaxis()->SetTitle("Channel ID sensor65");
  channel_s65_vs_channel_s67->GetYaxis()->SetTitle("Channel ID sensor67");

  d.cd(5); channel_s65_vs_channel_s69->Draw();
  channel_s65_vs_channel_s69->GetXaxis()->SetTitle("Channel ID sensor65");
  channel_s65_vs_channel_s69->GetYaxis()->SetTitle("Channel ID sensor69");

  d.cd(6); channel_s67_vs_channel_s69->Draw();
  channel_s67_vs_channel_s69->GetXaxis()->SetTitle("Channel ID sensor67");
  channel_s67_vs_channel_s69->GetYaxis()->SetTitle("Channel ID sensor69");

  d.cd(7); nClustervsZ->Draw();

  TCanvas d1("ClusterHisto11","Channels ID for each sensors",cw,ch);
  pDate.Draw(); pTitle.Draw();

  d1.Divide(2,3);

  d1.cd(1); channelID_s1->Draw();
  d1.cd(3); channelID_s3->Draw();
  d1.cd(5); channelID_s5->Draw();
  d1.cd(2); channelID_s65->Draw();
  d1.cd(4); channelID_s67->Draw();
  d1.cd(6); channelID_s69->Draw();
  }

  if(0){

  //----------------------------------------------------------------------------
  //Draw general track informations
  //----------------------------------------------------------------------------
  
  ClusterHisto->cd("VeloTrackDataMonitor");

  TCanvas e("TrackHisto01","R & Phi positions in global/local coordinates",cw,ch);
  pDate.Draw();pTitle.Draw();

  e.Divide(2,3);

  e.cd(1); ClusterInTrackPhiGlobal->Draw();
  e.cd(3); ClusterInTrackPhiLocal->Draw();
  e.cd(5); ClusterInTrackPhiVsZ->Draw("BOX");
  ClusterInTrackPhiVsZ->GetXaxis()->SetRangeUser(-20,0);
  e.cd(2); ClusterInTrackRvsZ->Draw("BOX");
  ClusterInTrackRvsZ->GetXaxis()->SetRangeUser(-20,0);
  e.cd(4); RvsPhiGlobal->Draw("BOX");
  RvsPhiGlobal->GetXaxis()->SetTitle("R(mm)");
  RvsPhiGlobal->GetYaxis()->SetTitle("Phi(degrees)");
  e.cd(6); RvsPhiLocal->Draw("BOX");
  RvsPhiLocal->GetXaxis()->SetTitle("R(mm)");
  RvsPhiLocal->GetYaxis()->SetTitle("Phi(degrees)");



  TCanvas f("TrackHisto02","XY Hitmaps",cw,ch);
  pDate.Draw();pTitle.Draw();

  f.Divide(1,3);

  // f.cd(1); XY_hitmap->Draw("BOX");
  //  XY_hitmap->GetXaxis()->SetRangeUser(-50,50);
  f.cd(1); XY_hitmap_mod1->Draw("BOX");
  //  XY_hitmap_mod1->GetXaxis()->SetRangeUser(-50,50);
  f.cd(2); XY_hitmap_mod3->Draw("BOX");
  //  XY_hitmap_mod3->GetXaxis()->SetRangeUser(-50,50);
  f.cd(3); XY_hitmap_mod5->Draw("BOX");
  //  XY_hitmap_mod5->GetXaxis()->SetRangeUser(-50,50);



  TCanvas g("TrackHisto04","Track residuals in each sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  g.Divide(2,3);

  g.cd(1); ExtrapResidsVsPhi_s65->Draw("BOX");
  ExtrapResidsVsPhi_s65->GetXaxis()->SetTitle("Phi position(degrees)");
  ExtrapResidsVsPhi_s65->GetYaxis()->SetTitle("Residuals(um)");

  g.cd(3); ExtrapResidsVsPhi_s67->Draw("BOX");
  ExtrapResidsVsPhi_s67->GetXaxis()->SetTitle("Phi position(degrees)");
  ExtrapResidsVsPhi_s67->GetYaxis()->SetTitle("Residuals(um)");

  g.cd(5); ExtrapResidsVsPhi_s69->Draw("BOX");
  ExtrapResidsVsPhi_s69->GetXaxis()->SetTitle("Phi position(degrees)");
  ExtrapResidsVsPhi_s69->GetYaxis()->SetTitle("Residuals(um)");

  g.cd(2); ExtrapResidsVsR_s1->Draw("BOX");
  ExtrapResidsVsR_s1->GetXaxis()->SetTitle("R position(mm)");
  ExtrapResidsVsR_s1->GetYaxis()->SetTitle("Residuals(um)");

  g.cd(4); ExtrapResidsVsR_s3->Draw("BOX");
  ExtrapResidsVsR_s3->GetXaxis()->SetTitle("R position(mm)");
  ExtrapResidsVsR_s3->GetYaxis()->SetTitle("Residuals(um)");

  g.cd(6); ExtrapResidsVsR_s5->Draw("BOX");
  ExtrapResidsVsR_s5->GetXaxis()->SetTitle("R position(mm)");
  ExtrapResidsVsR_s5->GetYaxis()->SetTitle("Residuals(um)");


  TCanvas g1("TrackHisto05","Track residual(mrad) of Phi sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  g1.Divide(2,3);

  g1.cd(1); ExtrapResidsPhiAngle_s65Inner->Draw();
  g1.cd(2); ExtrapResidsPhiAngle_s65Outer->Draw();
  g1.cd(3); ExtrapResidsPhiAngle_s67Inner->Draw();
  g1.cd(4); ExtrapResidsPhiAngle_s67Outer->Draw();
  g1.cd(5); ExtrapResidsPhiAngle_s69Inner->Draw();
  g1.cd(6); ExtrapResidsPhiAngle_s69Outer->Draw();

  TCanvas g4("TrackHisto08", "Track residuals(um) for Phi sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  g4.Divide(2,3);

  g4.cd(1); ExtrapResids_s65Inner->Draw();
  g4.cd(2); ExtrapResids_s65Outer->Draw();
  g4.cd(3); ExtrapResids_s67Inner->Draw();
  g4.cd(4); ExtrapResids_s67Outer->Draw();
  g4.cd(5); ExtrapResids_s69Inner->Draw();
  g4.cd(6); ExtrapResids_s69Outer->Draw();

  TCanvas g5("TrackHisto09","Track residuals(um) for R sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  g5.Divide(1,3);

  g5.cd(1); ExtrapResids_s1->Draw();
  g5.cd(2); ExtrapResids_s3->Draw();
  g5.cd(3); ExtrapResids_s5->Draw();

  TCanvas g6("TrackHisto10","Used/Unused sensors",cw,ch);
  pDate.Draw();pTitle.Draw();

  g6.Divide(2,2);

  g6.cd(1); UnusedSensors->Draw();
  g6.cd(2); UnusedSensorsInEvent->Draw();
  g6.cd(3); UsedSensorsR->Draw();
  g6.cd(4); UsedSensorsPhi->Draw();

  TCanvas g7("TrackHisto11","Display of all events",cw,ch,cw,ch);
  pDate.Draw();pTitle.Draw();

  g7.Divide(1,2);

  g7.cd(1); EventDisplaySelected->Draw();
  EventDisplaySelected->GetXaxis()->SetRangeUser(-20,-5);
  EventDisplaySelected->GetXaxis()->SetTitle("z position");
  EventDisplaySelected->GetYaxis()->SetTitle("x position");
  EventDisplaySelected->GetZaxis()->SetTitle("y position");

  g7.cd(2); EventDisplayAll->Draw();
  EventDisplayAll->GetXaxis()->SetRangeUser(-20,-5);
  EventDisplayAll->GetXaxis()->SetTitle("z position");
  EventDisplayAll->GetYaxis()->SetTitle("x position");
  EventDisplayAll->GetZaxis()->SetTitle("y position");



  ClusterHisto->cd("TrackDataMoniUserHistos");

  TCanvas h("TrackHisto12","Track positions for each module pair(Global coordinates)",cw,ch);
  pDate.Draw();pTitle.Draw();

  h.Divide(2,3);

  h.cd(1); x_pos_mod1_vs_x_pos_mod2->Draw();
  x_pos_mod1_vs_x_pos_mod2->GetXaxis()->SetTitle("x position module 1");
  x_pos_mod1_vs_x_pos_mod2->GetYaxis()->SetTitle("x position module 2");

  h.cd(2); y_pos_mod1_vs_y_pos_mod2->Draw();
  y_pos_mod1_vs_y_pos_mod2->GetXaxis()->SetTitle("y position module 1");
  y_pos_mod1_vs_y_pos_mod2->GetYaxis()->SetTitle("y position module 2");

  h.cd(3); x_pos_mod2_vs_x_pos_mod3->Draw();
  x_pos_mod2_vs_x_pos_mod3->GetXaxis()->SetTitle("x position module 2");
  x_pos_mod2_vs_x_pos_mod3->GetYaxis()->SetTitle("x position module 3");

  h.cd(4); y_pos_mod2_vs_y_pos_mod3->Draw();
  y_pos_mod2_vs_y_pos_mod3->GetXaxis()->SetTitle("y position module 2");
  y_pos_mod2_vs_y_pos_mod3->GetYaxis()->SetTitle("y position module 3");

  h.cd(5); x_pos_mod1_vs_x_pos_mod3->Draw();
  x_pos_mod1_vs_x_pos_mod3->GetXaxis()->SetTitle("x position module 1");
  x_pos_mod1_vs_x_pos_mod3->GetYaxis()->SetTitle("x position module 3");

  h.cd(6); y_pos_mod1_vs_y_pos_mod3->Draw();
  y_pos_mod1_vs_y_pos_mod3->GetXaxis()->SetTitle("y position module 1");
  y_pos_mod1_vs_y_pos_mod3->GetYaxis()->SetTitle("y position module 3");

  TCanvas h1("TrackHisto013","Local and global Phi coordinate of tracks",cw,ch);
  pDate.Draw();pTitle.Draw();

  h1.Divide(2,3);

  h1.cd(1); Phi_coor_s65_local->Draw();
  h1.cd(2); Phi_coor_s65_global->Draw();
  h1.cd(3); Phi_coor_s67_local->Draw();
  h1.cd(4); Phi_coor_s67_global->Draw();
  h1.cd(5); Phi_coor_s69_local->Draw();
  h1.cd(6); Phi_coor_s69_global->Draw();

  TCanvas h2("TrackHisto014","Local and global R coordinates of tracks",cw,ch);
  pDate.Draw();pTitle.Draw();

  h2.Divide(1,3);

  h2.cd(1); R_coor_s1_local->Draw();
  h2.cd(2); R_coor_s3_local->Draw();
  h2.cd(3); R_coor_s5_local->Draw();

  }//end of cutting out track histos

  a0->Print(Form("%s.ps(",title.Data()));
  b.Print(Form("%s.ps",title.Data()));
  a1.Print(Form("%s.ps",title.Data()));
  a2.Print(Form("%s.ps",title.Data()));
  c.Print(Form("%s.ps",title.Data()));
  c1.Print(Form("%s.ps",title.Data()));
  if(0){
  d1.Print(Form("%s.ps",title.Data()));
  d.Print(Form("%s.ps",title.Data()));
  e.Print(Form("%s.ps",title.Data()));
  g.Print(Form("%s.ps",title.Data()));
  g1.Print(Form("%s.ps",title.Data()));
  g4.Print(Form("%s.ps",title.Data()));
  g5.Print(Form("%s.ps",title.Data()));
  f.Print(Form("%s.ps",title.Data()));
  g7.Print(Form("%s.ps",title.Data()));
  h1.Print(Form("%s.ps",title.Data()));
  h2.Print(Form("%s.ps",title.Data()));
  h.Print(Form("%s.ps)",title.Data()));
  }

  gSystem->Exec(Form("ps2pdf %s.ps",title.Data()));
}



