int savePlot(char plotMsg[])
{
  char plotFile[50];
  char answer;

  cout << plotMsg << ", save plot (y/n/q)";

  //  answer = getchar();
  cin >> answer;

  if ( answer == 'q' ) {
    return 1;
  }

  if ( answer == 'y' ) {
    cout << "File name: ";
    cin >> plotFile;
    c1->Print(plotFile);
  }
  return 0;
}


void testPulse(char rootFile[]){
  int tell1Id = 30;
  testPulse(rootFile, tell1Id);
}


void testPulse(char rootFile[], int tell1Id){
  cout << "====  ROOT file:  " << rootFile << endl;
  cout << "====  TELL1 ID:   " << tell1Id << endl;
  
  // Open ROOT file and access (sub)directories
  TFile *ff=TFile::Open(rootFile);
  if ( ff == NULL ) {
    cout << " No such file!" << endl;
    return;
  }

  TDirectory *tdVetra = ff->Get("Vetra");
  if ( tdVetra == NULL ) {
    cout << " No Vetra directory " << endl;
    return;
  }

  char dirName[50];
  sprintf(dirName, "ADCTELL1%d", tell1Id );
  TDirectory *tdADC = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "CommonModeTELL1%d", tell1Id );
  TDirectory *tdCommonMode = tdVetra->Get(dirName);
  if ( tdCommonMode == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  sprintf(dirName, "PedAndNoiseTELL1%d", tell1Id );
  TDirectory *tdPedAndNoise = tdVetra->Get(dirName);
  if ( tdADC == NULL ) {
    cout << " Directory Vetra/" << dirName << " does not exist" << endl;
    return;
  }

  // Some variables
  int i, j;
  int iCard;
  int iChip;
  int iChipOld;
  int iLink;
  int iChannel;
  int link;
  int linkOld;
  int channel;
  char name[50];
  char title[50];
  Double_t parAll[9];


  // Get histogram from ROOT file and book more
  TH2F *hAllChannelsAfterCM = (TH2F *) tdCommonMode->Get("hAllChannelsAfterCM");
  TH1F *hnoiseChannel = (TH1F *) tdPedAndNoise->Get("hRMSEvenAfterCMMap");

  TH1F *hTestPulse_link[64];
  TH1F *noiseDist_link[64];
  TH1F *hTestPulse_low = new TH1F("hTestPulse_low", "Test pulse height vs link", 64, -0.5, 63.5);
  TH1F *hTestPulse_up  = new TH1F("hTestPulse_up",  "Test pulse height vs link", 64, -0.5, 63.5);
  TH1F *yNoise         = new TH1F("yNoise",     "Noise vs link", 64, -0.5, 63.5);
  TH1F *aTestPulse = new TH1F("aTestPulse", "Testpulse distribution", 100, 0.0, 100.0);
  TH1F *aNoise     = new TH1F("aNoise", "Noise distribution", 100, 0.0, 5.0);
  TH1F *aRatio     = new TH1F("aRatio", "Ratio distribution", 80, 0.0, 40.0);
  
  for ( iCard = 0; iCard < 4; iCard++ ) {
    for ( iChipOld = 0; iChipOld < 4; iChipOld++ ) {
      for ( iLink = 0; iLink < 4; iLink++ ) {
        if ( iChipOld < 2 ) {
          iChip = iChipOld+2;
        } else {
          iChip = iChipOld-2;
        }
        linkOld = iCard*16 + iChipOld*4 + iLink;
        link = iCard*16 + iChip*4 + iLink;

        // electronic noise of all channels in the link
        sprintf(name, "noiseDist_%d", link);
        sprintf(title, "Electronic Cms noise, card %d beetle %d link %d", iCard, iChip, iLink);
        noiseDist_link[link] = new TH1F(name, title, 50, 0.0, 5.0);

        for ( iChannel = 0; iChannel < 32; iChannel++ ) {
          if ( iChannel !=0 && iChannel != 3 && iChannel !=4 && iChannel !=5 &&
               iChannel !=22 && iChannel != 23 && iChannel != 24 ) {
            noiseDist_link[link]->Fill(hnoiseChannel->GetBinContent(iChannel+linkOld*32+1));
          }
        }
        noiseDist_link[link]->Fit("gaus", "QL");
        TF1 *fit = noiseDist_link[link]->GetFunction("gaus");
        yNoise->SetBinContent(link+1, fit->GetParameter(1));
        yNoise->SetBinError  (link+1, fit->GetParameter(2));
        
        // Test pulse
        sprintf(name, "hTestPulse_%d", link);
        hTestPulse_link[link] = (TH1F*) hAllChannelsAfterCM->ProjectionY(name, 32*linkOld, 32*linkOld+31);
        
        hTestPulse_link[link]->Fit("gaus", "QL", "", -100.0, -20.0);
        TF1 *fit = hTestPulse_link[link]->GetFunction("gaus");
        fit->GetParameters(&parAll[0]);
        hTestPulse_low->SetBinContent(link+1, parAll[1]);
        hTestPulse_low->SetBinError  (link+1, parAll[2]);

        hTestPulse_link[link]->Fit("gaus", "QL", "", 20.0, 100.0);
        fit->GetParameters(&parAll[0]);
        hTestPulse_up->SetBinContent(link+1, parAll[1]);
        hTestPulse_up->SetBinError  (link+1, parAll[2]);
      }
    }
  }

  // Low and high testpulse signal
  TH1F *hTestPulse_diff = (TH1F*) hTestPulse_up->Clone("hTestPulse_diff");
  hTestPulse_diff->Add(hTestPulse_low, -1.0);
  hTestPulse_diff->SetTitle("Test pulse (2Mips) vs link");

  // Signal to noise
  TH1F *hTestPulse_ratio = (TH1F*) hTestPulse_diff->Clone("hTestPulse_ratio");
  hTestPulse_ratio->Divide(hTestPulse_diff, yNoise, 1.0, 2.0, "");
  hTestPulse_ratio->SetTitle("Signal to noise ratio");

  for ( link=0; link<64; link++) {
    aTestPulse->Fill(hTestPulse_diff->GetBinContent(link+1));
    aNoise    ->Fill(yNoise         ->GetBinContent(link+1));
    aRatio    ->Fill(hTestPulse_ratio->GetBinContent(link+1));
  }

  // Print plots
  TCanvas *c1 = new TCanvas("c1", "", 10, 10, 600, 600);
  gStyle->SetOptStat("n"); // name only
  gStyle->SetOptFit(111);

  hTestPulse_diff->SetMinimum(0.0);
  hTestPulse_diff->SetMarkerStyle(20);
  hTestPulse_diff->SetMarkerColor(4);
  hTestPulse_diff->Draw();
  c1->Update();
  if ( savePlot("Test pulse height vs link") ) return;

  aTestPulse->Fit("gaus", "QL", " ", 3.0, 100.0);
  aTestPulse->GetXaxis()->SetRange(2, 100);
  aTestPulse->Draw();
  c1->Update();
  if ( savePlot("Test pulse height distribution") ) return;

  yNoise->SetMinimum(0.0);
  yNoise->SetMarkerStyle(20);
  yNoise->SetMarkerColor(4);
  yNoise->Draw();
  c1->Update();
  if ( savePlot("Test noise vs link") ) return;

  aNoise->Fit("gaus", "QL", " ", 0.5, 5.0);
  aNoise->GetXaxis()->SetRange(4, 100);
  aNoise->Draw();
  c1->Update();
  if ( savePlot("Total noise distribution") ) return;

  hTestPulse_ratio->SetMinimum(0.0);
  hTestPulse_ratio->SetMarkerStyle(20);
  hTestPulse_ratio->SetMarkerColor(4);
  hTestPulse_ratio->Draw();
  c1->Update();
  if ( savePlot("Test pulse height / (2*noise) vs link") ) return;

  aRatio->Fit("gaus","QL", " ", 1.0, 40.0);
  aRatio->GetXaxis()->SetRange(2, 80);
  aRatio->Draw();
  c1->Update();
  if ( savePlot("Signal to noise ratio distribution") ) return;
  

}


