void vertex(char inFile[]) 
{

  gROOT->SetStyle("Plain");
  gStyle->SetOptFit(1111111);
  
  TFile *ff=TFile::Open(inFile);
  if ( ff == NULL ) {
    cout << " No such file!" << endl;
    return;
  }

  TString inFileTString=TString(inFile);
  Size_t dotPosition =inFileTString.Index(".root");
  TString fileTitleTString = inFileTString(0,dotPosition);
  char fileTitle[400];
  strcpy(fileTitle, fileTitleTString.Data());

  // Date
  TDatime now;
  now.Get();
  TPaveLabel *pDate = new TPaveLabel(0,0,0.3,1,now.AsSQLString(),"NDC");
  pDate->SetBorderSize(0);
  pDate->SetTextFont(32);
  pDate->SetFillColor(0);
  
  // FileTitle
  TPaveLabel *pFileTitle = new TPaveLabel( 0.55, 0, 1, 1, fileTitle, "NDC");
  pFileTitle->SetBorderSize(0);
  pFileTitle->SetTextFont(32);
  pFileTitle->SetFillColor(0); 

  float border = 0.98;
 
///////////////////////////////////////// Track Hitmaps ALL

  TCanvas *c1 = new TCanvas("c1", "Vertices Positions", 10, 10, 700, 700);
  TPad *pPad1 = new TPad("pPad1", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad1 = new TPad("mPad1", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad1->Draw();pPad1->cd();pDate->Draw();pFileTitle->Draw();
  c1->cd(); mPad1->Draw(); mPad1->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  TString title_base = "vertexX_all";
  TString path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad1->cd(1);
    
    TH2D *tmp = (TH2D*)ff->Get(path_soft);
    tmp->SetTitle(title);
    ff->Get(path_soft)->Draw();
  }
      
  title_base = "vertexY_all";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad1->cd(2);
    
    TH2D *tmp2 = (TH2D*)ff->Get(path_soft);
    tmp2->SetTitle(title);
    ff->Get(path_soft)->Draw();
  }

  title_base = "vertexZ_all";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad1->cd(3);
    
    TH2D *tmp3 = (TH2D*)ff->Get(path_soft);
    tmp3->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }

  title_base = "vertexChi2";
  path_soft = path_base + title_base;

  
  if (ff->Get(path_soft)) {
  
    TString title = title_base;
    mPad1->cd(4);
    
    TH2D *tmp4 = (TH2D*)ff->Get(path_soft);
    tmp4->SetTitle(title);
    ff->Get(path_soft)->Draw();
  
  }

///////////////////////////////////////// Vertex Target 1

  TCanvas *c2 = new TCanvas("c2", "Vertices reconstructed target 1", 10, 10, 700, 700);
  TPad *pPad2 = new TPad("pPad2", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad2 = new TPad("mPad2", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad2->Draw();pPad2->cd();pDate->Draw();pFileTitle->Draw();
  c2->cd(); mPad2->Draw(); mPad2->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYtarget1";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad2->cd(1);
    
    TH2D *tmp11 = (TH2D*)ff->Get(path_soft);
    tmp11->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexTarget1_x_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad2->cd(2);
    
    TH2D *tmp12 = (TH2D*)ff->Get(path_soft);
    tmp12->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp12->Fit("gaus","+","",-20,20);
  }

  title_base = "vertexTarget1_y_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad2->cd(3);
    
    TH2D *tmp13 = (TH2D*)ff->Get(path_soft);
    tmp13->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp13->Fit("gaus","+","",-20,20);
    
  }

///////////////////////////////////////// Vertex Target 2


  TCanvas *c3 = new TCanvas("c3", "Vertices reconstructed Target 2", 10, 10, 700, 700);
  TPad *pPad3 = new TPad("pPad3", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad3 = new TPad("mPad3", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad3->Draw();pPad3->cd();pDate->Draw();pFileTitle->Draw();
  c3->cd(); mPad3->Draw(); mPad3->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYtarget2";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad3->cd(1);
    
    TH2D *tmp21 = (TH2D*)ff->Get(path_soft);
    tmp21->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexTarget2_x_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad3->cd(2);
    
    TH2D *tmp22 = (TH2D*)ff->Get(path_soft);
    tmp22->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp22->Fit("gaus","+","",-20,20);

  }

  title_base = "vertexTarget2_y_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad3->cd(3);
    
    TH2D *tmp23 = (TH2D*)ff->Get(path_soft);
    tmp23->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp23->Fit("gaus","+","",-20,20);
        
  }

///////////////////////////////////////// Vertex Target 3


  TCanvas *c4 = new TCanvas("c4", "Vertices reconstructed Target 3", 10, 10, 700, 700);
  TPad *pPad4 = new TPad("pPad4", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad4 = new TPad("mPad4", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad4->Draw();pPad4->cd();pDate->Draw();pFileTitle->Draw();
  c4->cd(); mPad4->Draw(); mPad4->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYtarget3";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad4->cd(1);
    
    TH2D *tmp31 = (TH2D*)ff->Get(path_soft);
    tmp31->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexTarget3_x_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad4->cd(2);
    
    TH2D *tmp32 = (TH2D*)ff->Get(path_soft);
    tmp32->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp32->Fit("gaus","+","",-20,20);

  }

  title_base = "vertexTarget3_y_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad4->cd(3);
    
    TH2D *tmp33 = (TH2D*)ff->Get(path_soft);
    tmp33->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp33->Fit("gaus","+","",-20,20);
    
  }

///////////////////////////////////////// Vertex Target 4


  TCanvas *c5 = new TCanvas("c5", "Vertices reconstructed Target 4", 10, 10, 700, 700);
  TPad *pPad5 = new TPad("pPad5", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad5 = new TPad("mPad5", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad5->Draw();pPad5->cd();pDate->Draw();pFileTitle->Draw();
  c5->cd(); mPad5->Draw(); mPad5->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYtarget4";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad5->cd(1);
    
    TH2D *tmp41 = (TH2D*)ff->Get(path_soft);
    tmp41->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexTarget4_x_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad5->cd(2);
    
    TH2D *tmp42 = (TH2D*)ff->Get(path_soft);
    tmp42->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp42->Fit("gaus","+","",-20,20);

  }

  title_base = "vertexTarget4_y_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad5->cd(3);
    
    TH2D *tmp43 = (TH2D*)ff->Get(path_soft);
    tmp43->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp43->Fit("gaus","+","",-20,20);
    
  }

///////////////////////////////////////// Vertex Beam Window


  TCanvas *c6 = new TCanvas("c6", "Vertices reconstructed Beam Window", 10, 10, 700, 700);
  TPad *pPad6 = new TPad("pPad6", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad6 = new TPad("mPad6", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad6->Draw();pPad6->cd();pDate->Draw();pFileTitle->Draw();
  c6->cd(); mPad6->Draw(); mPad6->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYwindow";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad6->cd(1);
    
    TH2D *tmp51 = (TH2D*)ff->Get(path_soft);
    tmp51->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexWindow_x_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad6->cd(2);
    
    TH2D *tmp52 = (TH2D*)ff->Get(path_soft);
    tmp52->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp52->Fit("gaus","+","",-20,20);

  }

  title_base = "vertexWindow_y_proj";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad6->cd(3);
    
    TH2D *tmp53 = (TH2D*)ff->Get(path_soft);
    tmp53->SetTitle(title);
    ff->Get(path_soft)->Draw();
    tmp53->Fit("gaus","+","",-20,20);
    
  }

//////////////////////////////////////////////

///////////////////////////////////////// Vertex Beam Window


  TCanvas *c7 = new TCanvas("c7", "Radius", 10, 10, 700, 700);
  TPad *pPad7 = new TPad("pPad7", "FileTitle Pad", 0.0, border, 1.0, 1.0);
  TPad *mPad7 = new TPad("mPad7", "Main Pad", 0.0, 0.0, 1.0, border);
  pPad7->Draw();pPad7->cd();pDate->Draw();pFileTitle->Draw();
  c7->cd(); mPad7->Draw(); mPad7->Divide(2,2);

  TString path_base = "TrackDataMoniUserHistos/";

  title_base = "vertexXYradius1";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad7->cd(1);
    
    TH2D *tmp61 = (TH2D*)ff->Get(path_soft);
    tmp61->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
      
  title_base = "vertexXYradius2";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad7->cd(2);
    
    TH2D *tmp62 = (TH2D*)ff->Get(path_soft);
    tmp62->SetTitle(title);
    ff->Get(path_soft)->Draw();

  }

  title_base = "vertexXYradius3";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad7->cd(3);
    
    TH2D *tmp63 = (TH2D*)ff->Get(path_soft);
    tmp63->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }
  
    title_base = "vertexXYradius4";
  path_soft = path_base + title_base;

  if(ff->Get(path_soft)) {
    
    TString title = title_base;
    mPad7->cd(4);
    
    TH2D *tmp63 = (TH2D*)ff->Get(path_soft);
    tmp63->SetTitle(title);
    ff->Get(path_soft)->Draw();
    
  }

//////////////////////////////////////////////


c1->Print(Form("Vertices_%s.ps(",fileTitle));
c2->Print(Form("Vertices_%s.ps",fileTitle));
c3->Print(Form("Vertices_%s.ps",fileTitle));
c4->Print(Form("Vertices_%s.ps",fileTitle));
c5->Print(Form("Vertices_%s.ps",fileTitle));
c6->Print(Form("Vertices_%s.ps)",fileTitle));

gSystem->Exec(Form("ps2pdf Vertices_%s.ps",fileTitle));
 
}



