// $Id: ClusterDataMoniUserHistos.h,v 1.3 2006/08/21 11:56:43 mjohn Exp $

#ifndef CLUSTERDATAMONIUSERHISTOS_H 
#define CLUSTERDATAMONIUSERHISTOS_H 1

// Include files

#include "VeloClusterDataMonitor.h"




/** @class ClusterDataMoniUserHistos ClusterDataMoniUserHistos.h
 *  
 *
 *  @author Aras Papadelis
 *  @date   2006-07-20

*/



class DeVelo;


class ClusterDataMoniUserHistos : public VeloClusterDataMonitor {
public: 
  /// Standard constructor
  ClusterDataMoniUserHistos( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~ClusterDataMoniUserHistos( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

  
protected:

private:
  bool m_plotHistos;

  StatusCode userHistos();

  DeVelo* m_veloDet;
  

  int  m_numberOfEvents;

  LHCb::VeloClusters* m_clusters;

  std::vector<double> x_mod1;
  std::vector<double> y_mod1;
  std::vector<double> x_mod2;
  std::vector<double> y_mod2;
  std::vector<double> x_mod3;
  std::vector<double> y_mod3;

};

#endif // CLUSTERDATAMONIUSERHISTOS_H
