#-- start of make_header -----------------

#====================================
#  Library VeloDAQ
#
#   Generated Tue Oct 14 15:01:56 2008  by dpennica
#
#====================================

include ${CMTROOT}/src/Makefile.core

ifdef tag
CMTEXTRATAGS = $(tag)
else
tag       = $(CMTCONFIG)
endif

cmt_VeloDAQ_has_no_target_tag = 1

#--------------------------------------------------------

ifdef cmt_VeloDAQ_has_target_tag

tags      = $(tag),$(CMTEXTRATAGS),target_VeloDAQ

VeloDAQ_tag = $(tag)

ifdef READONLY
cmt_local_tagfile_VeloDAQ = /tmp/CMT_$(VeloDAQ_tag)_VeloDAQ.make$(cmt_lock_pid)
else
cmt_local_tagfile_VeloDAQ = $(VeloDAQ_tag)_VeloDAQ.make
endif

else

tags      = $(tag),$(CMTEXTRATAGS)

VeloDAQ_tag = $(tag)

ifdef READONLY
cmt_local_tagfile_VeloDAQ = /tmp/CMT_$(VeloDAQ_tag).make$(cmt_lock_pid)
else
cmt_local_tagfile_VeloDAQ = $(VeloDAQ_tag).make
endif

endif

-include $(cmt_local_tagfile_VeloDAQ)

ifdef cmt_VeloDAQ_has_target_tag

ifdef READONLY
cmt_final_setup_VeloDAQ = /tmp/CMT_VeloDAQ_VeloDAQsetup.make
cmt_local_VeloDAQ_makefile = /tmp/CMT_VeloDAQ$(cmt_lock_pid).make
else
cmt_final_setup_VeloDAQ = $(bin)VeloDAQ_VeloDAQsetup.make
cmt_local_VeloDAQ_makefile = $(bin)VeloDAQ.make
endif

else

ifdef READONLY
cmt_final_setup_VeloDAQ = /tmp/CMT_VeloDAQsetup.make
cmt_local_VeloDAQ_makefile = /tmp/CMT_VeloDAQ$(cmt_lock_pid).make
else
cmt_final_setup_VeloDAQ = $(bin)VeloDAQsetup.make
cmt_local_VeloDAQ_makefile = $(bin)VeloDAQ.make
endif

endif

ifdef READONLY
cmt_final_setup = /tmp/CMT_VeloDAQsetup.make
else
cmt_final_setup = $(bin)VeloDAQsetup.make
endif

VeloDAQ ::


ifdef READONLY
VeloDAQ ::
	@echo tags=$(tags)
	@echo cmt_local_tagfile=$(cmt_local_tagfile)
endif


dirs ::
	@if test ! -r requirements ; then echo "No requirements file" ; fi; \
	  if test ! -d $(bin) ; then $(mkdir) -p $(bin) ; fi

javadirs ::
	@if test ! -d $(javabin) ; then $(mkdir) -p $(javabin) ; fi

srcdirs ::
	@if test ! -d $(src) ; then $(mkdir) -p $(src) ; fi

help ::
	@echo 'VeloDAQ'

binobj = 
ifdef STRUCTURED_OUTPUT
binobj = VeloDAQ/
VeloDAQ::
	@if test ! -d $(bin)$(binobj) ; then $(mkdir) -p $(bin)$(binobj) ; fi
	@echo "STRUCTURED_OUTPUT="$(bin)$(binobj)
endif

#-- end of make_header ------------------

#-- start of libary_header ---------------

VeloDAQlibname   = $(bin)$(library_prefix)VeloDAQ$(library_suffix)
VeloDAQlib       = $(VeloDAQlibname).a
VeloDAQstamp     = $(bin)VeloDAQ.stamp
VeloDAQshstamp   = $(bin)VeloDAQ.shstamp

VeloDAQ :: dirs  VeloDAQLIB
	@/bin/echo "------> VeloDAQ ok"

#-- end of libary_header ----------------
#-- start of libary ----------------------

VeloDAQLIB :: $(VeloDAQlib) $(VeloDAQshstamp)
	@/bin/echo "------> VeloDAQ : library ok"

$(VeloDAQlib) :: $(bin)DecodeRawBankToClusters.o $(bin)DecodeRawBankToLiteClusters.o $(bin)DecodeVeloRawBuffer.o $(bin)InternalVeloClusterPtrLessThan.o $(bin)PrepareVeloRawBuffer.o $(bin)VeloClusterPtrLessThan.o $(bin)VeloDAQ_dll.o $(bin)VeloDAQ_load.o
	$(lib_echo) library
	$(lib_silent) cd $(bin); \
	  $(ar) $(VeloDAQlib) $?
	$(lib_silent) $(ranlib) $(VeloDAQlib)
	$(lib_silent) cat /dev/null >$(VeloDAQstamp)

#------------------------------------------------------------------
#  Future improvement? to empty the object files after
#  storing in the library
#
##	  for f in $?; do \
##	    rm $${f}; touch $${f}; \
##	  done
#------------------------------------------------------------------

#
# We add one level of dependency upon the true shared library 
# (rather than simply upon the stamp file)
# this is for cases where the shared library has not been built
# while the stamp was created (error??) 
#

$(VeloDAQlibname).$(shlibsuffix) :: $(VeloDAQlib) requirements $(use_requirements) $(VeloDAQstamps)
	$(lib_silent) cd $(bin); QUIET=$(QUIET); $(make_shlib) "$(tags)" VeloDAQ $(VeloDAQ_shlibflags)

$(VeloDAQshstamp) :: $(VeloDAQlibname).$(shlibsuffix)
	@if test -f $(VeloDAQlibname).$(shlibsuffix) ; then cat /dev/null >$(VeloDAQshstamp) ; fi

VeloDAQclean ::
	$(cleanup_echo) objects
	$(cleanup_silent) cd $(bin); /bin/rm -f $(bin)DecodeRawBankToClusters.o $(bin)DecodeRawBankToLiteClusters.o $(bin)DecodeVeloRawBuffer.o $(bin)InternalVeloClusterPtrLessThan.o $(bin)PrepareVeloRawBuffer.o $(bin)VeloClusterPtrLessThan.o $(bin)VeloDAQ_dll.o $(bin)VeloDAQ_load.o
	$(cleanup_silent) cd $(bin); /bin/rm -rf VeloDAQ_deps VeloDAQ_dependencies.make

#-----------------------------------------------------------------
#
#  New section for automatic installation
#
#-----------------------------------------------------------------

install_dir = ${CMTINSTALLAREA}/$(tag)/lib
VeloDAQinstallname = $(library_prefix)VeloDAQ$(library_suffix).$(shlibsuffix)

VeloDAQ :: VeloDAQinstall

install :: VeloDAQinstall

VeloDAQinstall :: $(install_dir)/$(VeloDAQinstallname)
	@if test ! "${CMTINSTALLAREA}" = ""; then\
	  echo "installation done"; \
	fi

$(install_dir)/$(VeloDAQinstallname) :: $(bin)$(VeloDAQinstallname)
	@if test ! "${CMTINSTALLAREA}" = ""; then \
	  $(cmt_install_action) \
	    -source "`(cd $(bin); pwd)`" \
	    -name "$(VeloDAQinstallname)" \
	    -out "$(install_dir)" \
	    -cmd "$(cmt_installarea_command)" \
	    -cmtpath "$($(package)_cmtpath)" ; \
	fi

##VeloDAQclean :: VeloDAQuninstall

uninstall :: VeloDAQuninstall

VeloDAQuninstall ::
	@if test ! "${CMTINSTALLAREA}" = ""; then \
	  $(cmt_uninstall_action) \
	    -source "`(cd $(bin); pwd)`" \
	    -name "$(VeloDAQinstallname)" \
	    -out "$(install_dir)" \
	    -cmtpath "$($(package)_cmtpath)" ; \
	fi


#-- end of libary -----------------------
#-- start of dependency ------------------

$(bin)VeloDAQ_dependencies.make :: dirs

ifndef QUICK
$(bin)VeloDAQ_dependencies.make :: $(src)*.cpp  requirements $(use_requirements) $(cmt_final_setup_VeloDAQ)
	@echo "------> (VeloDAQ.make) Rebuilding $@"; \
	  args=`echo $? | sed -e "s#requirements.*##"`; \
	  $(build_dependencies) VeloDAQ -all_sources $${args}
endif

#$(VeloDAQ_dependencies)

-include $(bin)VeloDAQ_dependencies.make

#-- end of dependency -------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)DecodeRawBankToClusters.o : $(DecodeRawBankToClusters_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)DecodeRawBankToClusters.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(DecodeRawBankToClusters_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(DecodeRawBankToClusters_cppflags) $(DecodeRawBankToClusters_cpp_cppflags)  $(src)DecodeRawBankToClusters.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)DecodeRawBankToLiteClusters.o : $(DecodeRawBankToLiteClusters_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)DecodeRawBankToLiteClusters.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(DecodeRawBankToLiteClusters_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(DecodeRawBankToLiteClusters_cppflags) $(DecodeRawBankToLiteClusters_cpp_cppflags)  $(src)DecodeRawBankToLiteClusters.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)DecodeVeloRawBuffer.o : $(DecodeVeloRawBuffer_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)DecodeVeloRawBuffer.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(DecodeVeloRawBuffer_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(DecodeVeloRawBuffer_cppflags) $(DecodeVeloRawBuffer_cpp_cppflags)  $(src)DecodeVeloRawBuffer.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)InternalVeloClusterPtrLessThan.o : $(InternalVeloClusterPtrLessThan_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)InternalVeloClusterPtrLessThan.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(InternalVeloClusterPtrLessThan_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(InternalVeloClusterPtrLessThan_cppflags) $(InternalVeloClusterPtrLessThan_cpp_cppflags)  $(src)InternalVeloClusterPtrLessThan.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)PrepareVeloRawBuffer.o : $(PrepareVeloRawBuffer_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)PrepareVeloRawBuffer.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(PrepareVeloRawBuffer_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(PrepareVeloRawBuffer_cppflags) $(PrepareVeloRawBuffer_cpp_cppflags)  $(src)PrepareVeloRawBuffer.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)VeloClusterPtrLessThan.o : $(VeloClusterPtrLessThan_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)VeloClusterPtrLessThan.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(VeloClusterPtrLessThan_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(VeloClusterPtrLessThan_cppflags) $(VeloClusterPtrLessThan_cpp_cppflags)  $(src)VeloClusterPtrLessThan.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)VeloDAQ_dll.o : $(VeloDAQ_dll_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)VeloDAQ_dll.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(VeloDAQ_dll_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(VeloDAQ_dll_cppflags) $(VeloDAQ_dll_cpp_cppflags)  $(src)VeloDAQ_dll.cpp

#-- end of cpp_library ------------------
#-- start of cpp_library -----------------
#
$(bin)$(binobj)VeloDAQ_load.o : $(VeloDAQ_load_cpp_dependencies)
	$(cpp_echo) $@
	$(cpp_silent) cd $(bin); $(cppcomp) -o $(binobj)VeloDAQ_load.o $(use_pp_cppflags) $(VeloDAQ_pp_cppflags) $(lib_VeloDAQ_pp_cppflags) $(VeloDAQ_load_pp_cppflags) $(use_cppflags) $(VeloDAQ_cppflags) $(lib_VeloDAQ_cppflags) $(VeloDAQ_load_cppflags) $(VeloDAQ_load_cpp_cppflags)  $(src)VeloDAQ_load.cpp

#-- end of cpp_library ------------------
#-- start of cleanup_header --------------

clean :: VeloDAQclean
	@cd .

ifndef PEDANTIC
.DEFAULT::
	@echo "WARNING >> You should provide a target for $@"
else
.DEFAULT::
	@echo "PEDANTIC MODE >> You should provide a target for $@"
	@if test `expr index $@ '.'` != 0 ; \
	then  echo "PEDANTIC MODE >> This target seems to be a missing file, please check"; exit -1 ;\
	else echo "PEDANTIC MODE >> Just ignore it ; as it seems to be just a fake target due to some pattern" ; exit 0; fi; 		
endif

VeloDAQclean ::
#-- end of cleanup_header ---------------
#-- start of cleanup_library -------------
	$(cleanup_echo) library
	-$(cleanup_silent) cd $(bin); /bin/rm -f $(binobj)$(library_prefix)VeloDAQ$(library_suffix).a $(binobj)$(library_prefix)VeloDAQ$(library_suffix).s? $(binobj)VeloDAQ.stamp $(binobj)VeloDAQ.shstamp
#-- end of cleanup_library ---------------

