// $Id: VeloClusterCompare.h,v 1.2 2007/02/16 11:07:05 szumlat Exp $
#ifndef VELOCLUSTERCOMPARE_H 
#define VELOCLUSTERCOMPARE_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiTupleAlg.h"
#include "GaudiKernel/SystemOfUnits.h"

// velo
#include "Event/VeloCluster.h"

/** @class VeloClusterCompare VeloClusterCompare.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-01-25
 */

class DeVelo;

class VeloClusterCompare : public GaudiTupleAlg {
public: 
  /// Standard constructor
  VeloClusterCompare( const std::string& name, ISvcLocator* pSvcLocator );

  enum processLabels{
    TELL1=0,
    EMU=1
  };

  typedef std::pair<double, double> dPair;

  virtual ~VeloClusterCompare( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  StatusCode getData();
  void sortClusters();
  StatusCode clustersMonitor(LHCb::VeloClusters* inCont, const int procType);
  StatusCode emulatorPerformance();
  
private:

  std::string m_tell1ClustersLoc;
  std::string m_emuClustersLoc;
  long m_evtNumber;
  LHCb::VeloClusters* m_tell1Clusters;
  LHCb::VeloClusters* m_emuClusters;
  DeVelo* m_veloDet;
  dPair m_nRawClusters;
  dPair m_nRawClusters2;
  dPair m_nOneStr;
  dPair m_nTwoStr;
  dPair m_nThreeStr;
  dPair m_nFourStr;

};
#endif // VELOCLUSTERCOMPARE_H
