// $Id: VeloTELL1FIRFilter.h,v 1.2 2007/08/26 16:39:14 szumlat Exp $
#ifndef VELOTELL1FIRFILTER_H 
#define VELOTELL1FIRFILTER_H 1

// Include files
// TELL1 algorithm base class
#include "VeloTELL1Algorithm.h"

/** @class VeloTELL1FIRFilter VeloTELL1FIRFilter.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-01-29
 */

class TELL1FIRProcessEngine;

class VeloTELL1FIRFilter: public VeloTELL1Algorithm {
public: 

  /// Standard constructor
  VeloTELL1FIRFilter( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~VeloTELL1FIRFilter( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  void prepareEngine();
  StatusCode runFIRFilter();

private:

  float m_K0;
  float m_K1;
  float m_K2;
  TELL1FIRProcessEngine* m_firEngine;

};
#endif // VELOTELL1FIRFILTER_H
