// $Id: VeloTELL1LCMS.h,v 1.3 2007/08/26 16:39:14 szumlat Exp $
#ifndef VELOTELL1LCMS_H 
#define VELOTELL1LCMS_H 1

// Include files
#include "VeloTELL1Algorithm.h"

/** @class VeloTELL1LCMS VeloTELL1LCMS.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-02-01
 */

class TELL1LCMSProcessEngine;

class VeloTELL1LCMS: public VeloTELL1Algorithm {

public: 

  enum lcms{
    CENTRE_CHANNEL=16
  };
  
  /// Standard constructor
  VeloTELL1LCMS( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~VeloTELL1LCMS( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  void prepareEngine();
  StatusCode runLCMSuppression();
  StatusCode validationRun();

private:

  unsigned int m_evtNumber;
  bool m_testMode;
  int m_tmpCnt;
  TELL1LCMSProcessEngine* m_lcmsEngine;

};
#endif // VELOTELL1LCMS_H
