// $Id: dataTranslator.cpp,v 1.1 2007/08/26 16:39:15 szumlat Exp $
// Include files 

// from Gaudi
#include "GaudiKernel/DeclareFactoryEntries.h" 

// local
#include "dataTranslator.h"

using namespace LHCb;

//-----------------------------------------------------------------------------
// Implementation file for class : dataTranslator
//
// 2007-08-14 : Tomasz Szumlak
//-----------------------------------------------------------------------------

// Declaration of the Algorithm Factory
DECLARE_ALGORITHM_FACTORY( dataTranslator );


//=============================================================================
// Standard constructor, initializes variables
//=============================================================================
dataTranslator::dataTranslator( const std::string& name,
                                ISvcLocator* pSvcLocator)
  : VeloTELL1Algorithm (name, pSvcLocator)
{
  declareProperty("InputDataLoc", m_inputDataLoc=VeloTELL1DataLocation::ADCs);
  declareProperty("InsertDummyAtEnd", m_insertDummyAtEnd=false);
}
//=============================================================================
// Destructor
//=============================================================================
dataTranslator::~dataTranslator() {} 

//=============================================================================
// Initialization
//=============================================================================
StatusCode dataTranslator::initialize() {
  StatusCode sc = VeloTELL1Algorithm::initialize(); // must be executed first
  // error printed already by VeloTELL1Algorithm
  if ( sc.isFailure() ) return sc;

  debug() << "==> Initialize" << endmsg;

  return StatusCode::SUCCESS;
}
//=============================================================================
// Main execution
//=============================================================================
StatusCode dataTranslator::execute() {

  debug() << "==> Execute" << endmsg;
  // create input data that will conform to c-modules
  StatusCode dataStatus=getData();
  if(dataStatus.isSuccess()){
    prepareData(m_insertDummyAtEnd);
  }
  return StatusCode::SUCCESS;
}
//=============================================================================
//  Finalize
//=============================================================================
StatusCode dataTranslator::finalize() {

  debug() << "==> Finalize" << endmsg;
  // must be called after all other actions
  return VeloTELL1Algorithm::finalize();
}
//=============================================================================
