// $Id: dataTranslator.h,v 1.1 2007/08/26 16:39:15 szumlat Exp $
#ifndef DATATRANSLATOR_H 
#define DATATRANSLATOR_H 1

// Include files
// from Gaudi
#include "VeloTELL1Algorithm.h"

// form TELL1 Kernel
#include "Kernel/DecodeCore.h"

/** @class dataTranslator dataTranslator.h
 *  
 *  This algorithm should be executed ALWAYS as first in
 *  TELL1 emulator for Velo (after the emulator initialization).
 *  It will insert sequences of dummy strips within all decoded data.
 *
 *  @author Tomasz Szumlak
 *  @date   2007-08-14
 */

class dataTranslator: public VeloTELL1Algorithm{
public: 
  /// Standard constructor
  dataTranslator( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~dataTranslator( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

private:

  bool m_insertDummyAtEnd;

};
#endif // DATATRANSLATOR_H
