// $Id: VeloBitLimitMoni.h,v 1.3 2007/08/26 19:20:05 szumlat Exp $
#ifndef VELOBITLIMITMONI_H 
#define VELOBITLIMITMONI_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiTupleAlg.h"

// from TELL1 event
#include "Event/VeloTELL1Data.h"

/** @class VeloBitLimitMoni VeloBitLimitMoni.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-08-22
 */

class VeloBitLimitMoni : public GaudiTupleAlg {
public: 
  /// Standard constructor
  VeloBitLimitMoni( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~VeloBitLimitMoni( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  StatusCode getData();
  StatusCode plotSaturatedData();
  StatusCode storeNTuple();

private:

  LHCb::VeloTELL1Datas* m_bitLimit; /// ADC samples after saturation
  std::string m_bitLimitLoc;        /// the container name
  bool m_plotBitLimit;              /// saturated data will be plot
  unsigned int m_numberOfEvents;
  unsigned int m_subType;           /// by default fast subtractor is used (1)
  unsigned int m_convergenceLimit;
  int m_sizeOfNTupleArray;  
  bool m_storeNTuple;

};
#endif // VELOBITLIMITMONI_H
