// $Id: VeloChannelReordererMoni.h,v 1.2 2007/08/26 19:20:05 szumlat Exp $
#ifndef VELOCHANNELREORDERERMONI_H 
#define VELOCHANNELREORDERERMONI_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiTupleAlg.h"

// from Event
#include "Event/VeloTELL1Data.h"
#include "Event/VeloProcessInfo.h"

/** @class VeloChannelReordererMoni VeloChannelReordererMoni.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-10-23
 */

class VeloChannelReordererMoni : public GaudiTupleAlg{
public: 
  /// Standard constructor
  VeloChannelReordererMoni(const std::string& name, ISvcLocator* pSvcLocator);

  virtual ~VeloChannelReordererMoni( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:
  
  StatusCode getData();
  StatusCode plotReorderedData();

private:

  VeloProcessInfos* m_procInfos;
  std::string m_procInfosLoc;
  LHCb::VeloTELL1Datas* m_reordered; /// ADC samples after saturation
  std::string m_reorderedLoc;        /// the container name
  bool m_plotReordered;              /// saturated data will be plot
  unsigned int m_numberOfEvents;
  unsigned int m_convergenceLimit;
  unsigned int m_subType;            /// by default fast subtractor is used
  bool m_isInitialized;
  
};
#endif // VELOCHANNELREORDERERMONI_H
