// $Id: VeloLCMSMoni.h,v 1.2 2007/08/26 19:20:05 szumlat Exp $
#ifndef VELOLCMSMONI_H 
#define VELOLCMSMONI_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiTupleAlg.h"

// from TELL1 event
#include "Event/VeloTELL1Data.h"
#include "Event/VeloProcessInfo.h"

/** @class VeloLCMSMoni VeloLCMSMoni.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2007-02-09
 */

class VeloLCMSMoni : public GaudiTupleAlg{

public: 
  /// Standard constructor
  VeloLCMSMoni( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~VeloLCMSMoni( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  StatusCode getData();
  StatusCode plotLCMSData();

private:

  VeloProcessInfos* m_procInfos;
  std::string m_procInfosLoc;
  LHCb::VeloTELL1Datas* m_LCMSADCs;  /// ADC samples after reordering
  std::string m_LCMSADCsLoc;         /// the container name
  unsigned long m_eventNumber;      /// number of processed events
  bool m_plotLCMS;                  /// plot LCM suppressed data
  bool m_isInitialized;
  unsigned int m_convergenceLimit;

};
#endif // VELOLCMSMONI_H
