// $Id: VeloTELL1ErrorBankReader.h,v 1.1 2007/08/26 19:20:05 szumlat Exp $
#ifndef VELOTELL1ERRORBANKREADER_H 
#define VELOTELL1ERRORBANKREADER_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiTupleAlg.h"
#include "Event/EvtInfo.h"
#include "Event/ErrorBank.h"

/** @class VeloTELL1ErrorBankReader VeloTELL1ErrorBankReader.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-05-26
 */

class VeloTELL1ErrorBankReader : public GaudiTupleAlg {
public: 
  /// Standard constructor
  VeloTELL1ErrorBankReader( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~VeloTELL1ErrorBankReader( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  StatusCode getData();
  StatusCode getAllSensors();
  StatusCode dumpEvtInfo(EvtInfo*& anInfo);

private:

  std::string m_errorBankLoc;
  ErrorBanks* m_errorBanks;
  bool m_isErrorBank;
  bool m_printInfo;
  
};
#endif // VELOTELL1ERRORBANKREARED_H
